---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/5/27 15:35
---
GW_HeroDetailWindow = GW_HeroDetailWindow or BaseClass(BaseView)

local controller = HeroController:getInstance()
local model = controller:getModel()
local role_vo = RoleController:getInstance():getRoleVo()

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_HeroDetailWindow:__init()
    self.ctrl = GW_HeroDetailController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_hero_bag/gw_hero_detail_window"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_hero", "gw_hero"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_hero_bag","img_yingxiong", true), type = ResourcesType.single },
    }

    --装备位置列表
    self.equip_type_list = HeroConst.EquipPosList
    --神器解锁条件
    self.artifact_lock_list = model.artifact_lock_list

    self.born_limit_lev = 100
    local config = Config.PartnerData.data_partner_const.born_limit_lev
    if config then
        self.born_limit_lev = config.val
    end
end

--@show_list 英雄数据列表
--@index 当前显示的序号
--@sheet_type 英雄详情页签GW_HeroBagConst.Hero_Detail_Sheet_Type
function GW_HeroDetailWindow:openRootWnd(show_list, index, sheet_type)
    ExchangeController:getInstance():send23606()
    self.last_hp = nil
    self.last_def = nil
    self.last_atk = nil
    self.last_speed = nil
    self.num_change_flag = false
    self.break_effect_flag = false
    self.last_break_count = nil
    self.sheet_type = sheet_type or GW_HeroBagConst.Hero_Detail_Sheet_Type.Info
    self.index = index
    self.show_list = show_list
    self.library_config = nil
    --材料列表
    self.upgrade_star_cost_item_list = {} -- 升星额外消耗的材料

    self:setSheetTypeUI()
end

function GW_HeroDetailWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())
    self.bottom_container = self.root_wnd:getChildByName("bottom_container")
    self.bottom_container:setPositionY(display.getBottom())
    self.sheet_node = self.bottom_container:getChildByName("sheet_node")
    self.sheet_node:setPositionX(display.getRight())
    self.bottom_bg = self.bottom_container:getChildByName("bg")
    self.bottom_bg:setContentSize(cc.size(display.width, 120))

    --左上角英雄名称-英雄阵营-英雄星星-英雄锁定
    self.top_left_hero_info = self.left_top_container:getChildByName("hero_info")
    self.top_left_hero_info.camp_type = self.top_left_hero_info:getChildByName("camp_bg"):getChildByName("icon")
    self.top_left_hero_info.name = self.top_left_hero_info:getChildByName("name")
    self.top_left_hero_info.star = self.top_left_hero_info:getChildByName("star")
    self.top_left_hero_info.star_spine_node = self.top_left_hero_info:getChildByName("star_spine_node")
    self.top_left_hero_info.lock_btn = self.top_left_hero_info:getChildByName("lock_btn")
    self.top_left_hero_info.lock_btn:setVisible(false)
    self.top_left_hero_info.unlock_btn = self.top_left_hero_info:getChildByName("unlock_btn")
    self.top_left_hero_info.unlock_btn:setVisible(false)
    self.top_left_hero_info.reset_btn = self.top_left_hero_info:getChildByName("reset_btn")
    self.top_left_hero_info.reset_btn:setVisible(false)

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_hero_bag", "img_yingxiong", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    self.draw_move_btn = self.root_wnd:getChildByName("draw_move_btn")
    self.draw_move_btn:setScale(display.getMaxScale())
    self.draw_move_btn:addTouchEventListener(function(sender, event_type)
        if event_type == ccui.TouchEventType.began then
            self.touch_began = sender:getTouchBeganPosition()
            self.touch_move = nil
        elseif event_type == ccui.TouchEventType.moved then
            self.touch_move = sender:getTouchMovePosition()
            --local touch_began = self.touch_began
            --local touch_end = sender:getTouchMovePosition()
            --if touch_began and touch_end then
            --    if math.abs(touch_end.x - touch_began.x) > 1 or math.abs(touch_end.y - touch_began.y) > 1 then
            --        Debug.info(touch_end.x - touch_began.x)
            --        Debug.info(touch_end.y - touch_began.y)
            --    end
            --end
        elseif event_type == ccui.TouchEventType.canceled then
        elseif event_type == ccui.TouchEventType.ended then
            local touch_began = self.touch_began
            local touch_end = self.touch_move
            if touch_began and touch_end then
                if math.abs(touch_end.x - touch_began.x) > 50 then
                    if touch_end.x - touch_began.x > 0 then
                        self:onClickToRightBtn()
                    else
                        self:onClickToLeftBtn()
                    end
                end
            end

            self.touch_began = nil
            self.touch_move = nil
        end
    end)

    local background_spine_node = self.root_wnd:getChildByName("background_spine_node")
    self.background_spine = gw_createEffectSpine("E90102", cc.p(0, 0), cc.p(0.5, 0.5), true, "animation")
    background_spine_node:addChild(self.background_spine)

    local screen_spine_node = self.root_wnd:getChildByName("screen_spine_node")
    self.screen_spine = gw_createEffectSpine("E90101", cc.p(0, 0), cc.p(0.5, 0.5), true, "animation")
    screen_spine_node:addChild(self.screen_spine)

    self.hero_shipment = self.root_wnd:getChildByName("hero_shipment")
    self.hero_shipment:setPositionX(display.getRight() - 715)
    self.hero_draw_node = self.root_wnd:getChildByName("hero_draw_node")
    self.hero_draw = self.hero_draw_node:getChildByName("hero_draw")
    self.hero_spine_node = self.root_wnd:getChildByName("hero_spine_node")
    self.hero_spine_node_pos_x = display.getLeft() + 127
    self.hero_spine_node:setPositionX(self.hero_spine_node_pos_x)
    self.hero_spine_node:setPositionY(display.getBottom() + 199)
    self.hero_spine_node_camp = self.hero_spine_node:getChildByName("camp")
    self.hero_spine_node_spine_node = self.hero_spine_node:getChildByName("spine_node")

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.break_effect_flag == false and self.num_change_flag == false then
                self.ctrl:closeHeroDetailView()
            end
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            if self.break_effect_flag == false and self.num_change_flag == false then
                BackToHome()
            end
        end
    end)

    --前一个
    self.to_left_btn = self.root_wnd:getChildByName("to_left_btn")
    self.to_left_btn:setPositionX(display.getLeft() + 95)
    --后一个
    self.to_right_btn = self.root_wnd:getChildByName("to_right_btn")
    self.to_right_btn:setPositionX(display.getRight() - 646)
    --self.hero_draw_node_pos_x = (self.to_right_btn:getPositionX() - self.to_left_btn:getPositionX())*0.5 + self.to_left_btn:getPositionX()
    self.hero_draw_node_pos_x = self.hero_draw_node:getPositionX()
    self.hero_draw_node:setPositionX(self.hero_draw_node_pos_x)

    --页签
    self.sheet_btn_list = {}
    for i=1,5 do
        self.sheet_btn_list[i] = self.sheet_node:getChildByName("sheet_btn"..i)
        self.sheet_btn_list[i].normal = self.sheet_btn_list[i]:getChildByName("normal")
        self.sheet_btn_list[i].select = self.sheet_btn_list[i]:getChildByName("select")
        self.sheet_btn_list[i].normal:getChildByName("label"):setString(GW_HeroBagConst.Hero_Detail_Sheet_Name[i-1])
        self.sheet_btn_list[i].select:getChildByName("label"):setString(GW_HeroBagConst.Hero_Detail_Sheet_Name[i-1])
        self.sheet_btn_list[i].red_point = self.sheet_node:getChildByName("red_point"..i)
        self.sheet_btn_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickSheetBtn(i-1)
            end
        end)
    end
    local spine_node = self.sheet_btn_list[1].select:getChildByName("spine_node")
    function onSheetBtn1SpineCallBack()
        if self.sheet_btn_list[1].spine_flag == true then
            self.sheet_btn_list[1].spine_flag = false
            self.sheet_btn_list[1].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[1].spine_flag = false
    self.sheet_btn_list[1].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn1SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[1].spine)
    local spine_node = self.sheet_btn_list[2].select:getChildByName("spine_node")
    function onSheetBtn2SpineCallBack()
        if self.sheet_btn_list[2].spine_flag == true then
            self.sheet_btn_list[2].spine_flag = false
            self.sheet_btn_list[2].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[2].spine_flag = false
    self.sheet_btn_list[2].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn2SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[2].spine)
    local spine_node = self.sheet_btn_list[3].select:getChildByName("spine_node")
    function onSheetBtn3SpineCallBack()
        if self.sheet_btn_list[3].spine_flag == true then
            self.sheet_btn_list[3].spine_flag = false
            self.sheet_btn_list[3].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[3].spine_flag = false
    self.sheet_btn_list[3].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn3SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[3].spine)
    local spine_node = self.sheet_btn_list[4].select:getChildByName("spine_node")
    function onSheetBtn4SpineCallBack()
        if self.sheet_btn_list[4].spine_flag == true then
            self.sheet_btn_list[4].spine_flag = false
            self.sheet_btn_list[4].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[4].spine_flag = false
    self.sheet_btn_list[4].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn4SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[4].spine)
    local spine_node = self.sheet_btn_list[5].select:getChildByName("spine_node")
    function onSheetBtn5SpineCallBack()
        if self.sheet_btn_list[5].spine_flag == true then
            self.sheet_btn_list[5].spine_flag = false
            self.sheet_btn_list[5].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[5].spine_flag = false
    self.sheet_btn_list[5].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn5SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[5].spine)

    self.info_node = self.root_wnd:getChildByName("info_node")
    self.info_node:setPositionX(display.getRight() - 298)
    self.info_node:setPositionY(display.getBottom() + 369)
    self.info_node_lv_label2 = self.info_node:getChildByName("lev_label2")
    self.info_node_lv_label3 = self.info_node:getChildByName("lev_label3")
    self.info_node_lv_bar = self.info_node:getChildByName("lev_bar")
    self.info_node_lv_bar:setScale9Enabled(true)
    self.info_node_lv_bar:setPercent(0)
    self.info_node_battle_node = self.info_node:getChildByName("battle_node")
    self.info_node_battle_info_spine = gw_createEffectSpine("E90136", cc.p(0, 0), cc.p(0.5, 0.5), true, "animation")
    self.info_node_battle_info_spine:setScale(0.78)
    self.info_node_battle_info_spine:setPositionY(-24)
    self.info_node_battle_node:addChild(self.info_node_battle_info_spine)
    self.info_node_battle_info_power = CommonNum.new(104, self.info_node_battle_node, nil, -20, cc.p(1, 0.5))
    self.info_node_battle_info_power:setScale(0.78)
    self.info_node_battle_info_power:setPositionX(0)
    self.info_node_battle_info_power:setPositionY(0)
    --self.info_node_battle_info_power:setLocalZOrder(99)
    self.info_node_battle_info_power:setCallBack(function()
        local pos_x = 0 - self.info_node_battle_info_power:getContentSize().width * 0.78 - 15
        self.info_node_battle_info_spine:setPositionX(pos_x)
    end)
    --self.info_node_battle_label = self.info_node:getChildByName("battle_label")
    --self.info_node_battle_icon = self.info_node:getChildByName("battle_icon")
    self.info_node:getChildByName("stage_label"):setString(UI_TI18N(1111))
    local info_node_stage_con = self.info_node:getChildByName("stage_con")
    self.info_node_stage_con = info_node_stage_con
    self.info_node_stage_bg_list = {}
    for i=1,7 do
        self.info_node_stage_bg_list[i] =info_node_stage_con:getChildByName("bg"..i)
        self.info_node_stage_bg_list[i]:setVisible(false)
    end
    self.info_node_stage_list = {}
    for i=1,7 do
        self.info_node_stage_list[i] =info_node_stage_con:getChildByName("stage"..i)
        self.info_node_stage_list[i]:setVisible(false)
    end
    self.info_node_lv_max_btn = self.info_node:getChildByName("lev_max_btn")
    self.info_node_lv_max_btn:setVisible(false)
    self.info_node_lv_max_btn:getChildByName("label"):setString(UI_TI18N(1116))
    self.info_node_lv_up_btn = self.info_node:getChildByName("lev_up_btn")
    self.info_node_lv_up_btn:setVisible(false)
    self.info_node_lv_up_btn_label1 = self.info_node_lv_up_btn:getChildByName("label1")
    self.info_node_lv_up_btn_label2 = self.info_node_lv_up_btn:getChildByName("label2")
    self.info_node_lv_up_btn_redpoint = self.info_node_lv_up_btn:getChildByName("redpoint")
    self.info_node_lev_breach_btn = self.info_node:getChildByName("lev_breach_btn")
    self.info_node_lev_breach_btn:getChildByName("label"):setString(UI_TI18N(1113))
    self.info_node_lev_breach_btn:setVisible(false)
    self.info_node_lev_breach_btn_redpoint = self.info_node_lev_breach_btn:getChildByName("redpoint")
    self.info_node_lv_consume = {}
    for i=1,3 do
        self.info_node_lv_consume[i] = {}
        self.info_node_lv_consume[i].icon = self.info_node:getChildByName(string_format("lv_consume%s_icon", i))
        self.info_node_lv_consume[i].num = self.info_node:getChildByName(string_format("lv_consume%s_num", i))
        self.info_node_lv_consume[i].line = self.info_node:getChildByName(string_format("lv_consume%s_line", i))
    end
    self.info_node_profession_label_bg = self.info_node:getChildByName("profession_label_bg")
    self.info_node_profession_label_bg_career = self.info_node_profession_label_bg:getChildByName("career")
    self.info_node_profession_label_bg_desc_label = self.info_node_profession_label_bg:getChildByName("desc_label")
    self.info_node_profession_label_bg_tips_btn = self.info_node_profession_label_bg:getChildByName("tips_btn")
    self.info_node_hp_attr_value_label = self.info_node:getChildByName("attr_hp"):getChildByName("label")
    self.info_node_hp_attr_spine_node = self.info_node:getChildByName("attr_hp"):getChildByName("spine_node")
    self.info_node_def_attr_value_label = self.info_node:getChildByName("attr_def"):getChildByName("label")
    self.info_node_def_attr_spine_node = self.info_node:getChildByName("attr_def"):getChildByName("spine_node")
    self.info_node_atk_attr_value_label = self.info_node:getChildByName("attr_atk"):getChildByName("label")
    self.info_node_atk_attr_spine_node = self.info_node:getChildByName("attr_atk"):getChildByName("spine_node")
    self.info_node_speed_attr_value_label = self.info_node:getChildByName("attr_speed"):getChildByName("label")
    self.info_node_speed_attr_spine_node = self.info_node:getChildByName("attr_speed"):getChildByName("spine_node")
    self.info_node_skill_label_bg = self.info_node:getChildByName("skill_label_bg")
    self.info_node_skill_label_bg_label = self.info_node_skill_label_bg:getChildByName("label")
    self.info_node_skill_label_bg_label:setString(UI_TI18N(1112))
    self.info_node_skill_list = {}
    for i=1,4 do
        self.info_node_skill_list[i] = self.info_node:getChildByName(string_format("skill%s_node", i))
        self.info_node_skill_list[i].icon = self.info_node_skill_list[i]:getChildByName("icon")
        self.info_node_skill_list[i].lev_bg = self.info_node_skill_list[i]:getChildByName("lev_bg")
        self.info_node_skill_list[i].lev_label = self.info_node_skill_list[i]:getChildByName("lev_label")
        self.info_node_skill_list[i].icon_cover = self.info_node_skill_list[i]:getChildByName("icon_cover")
        self.info_node_skill_list[i].lock_icon = self.info_node_skill_list[i]:getChildByName("lock_icon")
        self.info_node_skill_list[i].skill_bid = nil
        self.info_node_skill_list[i].is_lock = true
        self.info_node_skill_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickInfoNodeSkillBtn(self.info_node_skill_list[i].skill_bid, self.info_node_skill_list[i].is_lock)
            end
        end)
    end

    self.equip_node = self.root_wnd:getChildByName("equip_node")
    self.equip_node:setPositionX(display.getRight() - 298)
    self.equip_node:setPositionY(display.getBottom() + 369)
    self.equip_node:getChildByName("title"):setString(UI_TI18N(1148))
    self.equip_node_key_up_btn = self.equip_node:getChildByName("key_up_btn")
    self.equip_node_key_up_btn:getChildByName("label"):setString(UI_TI18N(1121))
    self.equip_node_key_up_btn_redpoint = self.equip_node_key_up_btn:getChildByName("redpoint")
    --self.equip_node_key_up_btn:setVisible(false)
    self.equip_node_discharge_btn = self.equip_node:getChildByName("discharge_btn")
    self.equip_node_discharge_btn:getChildByName("label"):setString(UI_TI18N(1122))
    --self.equip_node_discharge_btn:setVisible(false)
    self.equip_node_list = {}
    for i=1,7 do
        self.equip_node_list[i] = {}
        self.equip_node_list[i] = self.equip_node:getChildByName(string_format("equip_node%s", i))
        self.equip_node_list[i].lock_bg = self.equip_node_list[i]:getChildByName("lock_bg")
        self.equip_node_list[i].unlock_bg = self.equip_node_list[i]:getChildByName("unlock_bg")
        self.equip_node_list[i].empty_icon = self.equip_node_list[i]:getChildByName("empty_icon")
        --self.equip_node_list[i].icon = self.equip_node_list[i]:getChildByName("icon")
        --self.equip_node_list[i].stage = self.equip_node_list[i]:getChildByName("stage")
        self.equip_node_list[i].item_node = self.equip_node_list[i]:getChildByName("item_node")
        self.equip_node_list[i].item_node:setVisible(false)
        self.equip_node_list[i].item = GW_GoodsItem3.new(false, false, false, 0.84, false, false)
        self.equip_node_list[i].item:gw_showShadow()
        self.equip_node_list[i].item_node:addChild(self.equip_node_list[i].item)
        self.equip_node_list[i].lock = self.equip_node_list[i]:getChildByName("lock")
        self.equip_node_list[i].redpoint = self.equip_node_list[i]:getChildByName("redpoint")
        self.equip_node_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickEquipNodeSelectEquipByIndex(i)
            end
        end)
    end

    self.upgrade_star_node = self.root_wnd:getChildByName("upgrade_star_node")
    self.upgrade_star_node:setPositionX(display.getRight() - 298)
    self.upgrade_star_node:setPositionY(display.getBottom() + 369)
    self.upgrade_star_node:getChildByName("title"):setString(UI_TI18N(1131))
    self.upgrade_star_node_star = self.upgrade_star_node:getChildByName("star")
    self.upgrade_star_node_lev_max = self.upgrade_star_node:getChildByName("lev_max")
    self.upgrade_star_node_lev_max:getChildByName("title"):setString(UI_TI18N(1133))
    self.upgrade_star_node_lev_max.cur_max = self.upgrade_star_node_lev_max:getChildByName("cur_max")
    self.upgrade_star_node_lev_max.next_max = self.upgrade_star_node_lev_max:getChildByName("next_max")
    self.upgrade_star_node_skill_lev = self.upgrade_star_node:getChildByName("skill_lev")
    self.upgrade_star_node_skill_lev.title = self.upgrade_star_node_skill_lev:getChildByName("title")
    --self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(1134))
    self.upgrade_star_node_skill_lev.cur_max = self.upgrade_star_node_skill_lev:getChildByName("cur_max")
    self.upgrade_star_node_skill_lev.next_max = self.upgrade_star_node_skill_lev:getChildByName("next_max")
    self.upgrade_star_node_hp_attr = self.upgrade_star_node:getChildByName("hp_attr")
    self.upgrade_star_node_hp_attr.rise_value_bg = self.upgrade_star_node_hp_attr:getChildByName("rise_value_bg")
    self.upgrade_star_node_hp_attr.cur_value = self.upgrade_star_node_hp_attr:getChildByName("cur_value")
    self.upgrade_star_node_hp_attr.next_value = self.upgrade_star_node_hp_attr:getChildByName("next_value")
    self.upgrade_star_node_hp_attr.rise_arrow = self.upgrade_star_node_hp_attr:getChildByName("rise_arrow")
    self.upgrade_star_node_hp_attr.rise_value = self.upgrade_star_node_hp_attr:getChildByName("rise_value")
    self.upgrade_star_node_def_attr = self.upgrade_star_node:getChildByName("def_attr")
    self.upgrade_star_node_def_attr.rise_value_bg = self.upgrade_star_node_def_attr:getChildByName("rise_value_bg")
    self.upgrade_star_node_def_attr.cur_value = self.upgrade_star_node_def_attr:getChildByName("cur_value")
    self.upgrade_star_node_def_attr.next_value = self.upgrade_star_node_def_attr:getChildByName("next_value")
    self.upgrade_star_node_def_attr.rise_arrow = self.upgrade_star_node_def_attr:getChildByName("rise_arrow")
    self.upgrade_star_node_def_attr.rise_value = self.upgrade_star_node_def_attr:getChildByName("rise_value")
    self.upgrade_star_node_atk_attr = self.upgrade_star_node:getChildByName("atk_attr")
    self.upgrade_star_node_atk_attr.rise_value_bg = self.upgrade_star_node_atk_attr:getChildByName("rise_value_bg")
    self.upgrade_star_node_atk_attr.cur_value = self.upgrade_star_node_atk_attr:getChildByName("cur_value")
    self.upgrade_star_node_atk_attr.next_value = self.upgrade_star_node_atk_attr:getChildByName("next_value")
    self.upgrade_star_node_atk_attr.rise_arrow = self.upgrade_star_node_atk_attr:getChildByName("rise_arrow")
    self.upgrade_star_node_atk_attr.rise_value = self.upgrade_star_node_atk_attr:getChildByName("rise_value")
    self.upgrade_star_node_speed_attr = self.upgrade_star_node:getChildByName("speed_attr")
    self.upgrade_star_node_speed_attr.rise_value_bg = self.upgrade_star_node_speed_attr:getChildByName("rise_value_bg")
    self.upgrade_star_node_speed_attr.cur_value = self.upgrade_star_node_speed_attr:getChildByName("cur_value")
    self.upgrade_star_node_speed_attr.next_value = self.upgrade_star_node_speed_attr:getChildByName("next_value")
    self.upgrade_star_node_speed_attr.rise_arrow = self.upgrade_star_node_speed_attr:getChildByName("rise_arrow")
    self.upgrade_star_node_speed_attr.rise_value = self.upgrade_star_node_speed_attr:getChildByName("rise_value")
    self.upgrade_star_node_upgrade_star_btn = self.upgrade_star_node:getChildByName("upgrade_star_btn")
    self.upgrade_star_node_upgrade_star_btn:getChildByName("label"):setString(UI_TI18N(1135))
    self.upgrade_star_node_upgrade_star_btn_redpoint = self.upgrade_star_node_upgrade_star_btn:getChildByName("redpoint")
    self.upgrade_star_node_consume_coin_bg = self.upgrade_star_node:getChildByName("consume_coin_bg")
    self.upgrade_star_node_consume_coin_bg_icon = self.upgrade_star_node_consume_coin_bg:getChildByName("icon")
    self.upgrade_star_node_consume_coin_bg_label1 = self.upgrade_star_node_consume_coin_bg:getChildByName("label1")
    self.upgrade_star_node_consume_coin_bg_label2 = self.upgrade_star_node_consume_coin_bg:getChildByName("label2")
    local item_node = self.upgrade_star_node:getChildByName("item_node")
    self.upgrade_star_node_item_list = {}
    for i=1,4 do
        self.upgrade_star_node_item_list[i] = item_node:getChildByName("item"..i)
        local icon_info = self.upgrade_star_node_item_list[i]:getChildByName("icon_info")
        self.upgrade_star_node_item_list[i].icon_info = icon_info
        self.upgrade_star_node_item_list[i].icon = icon_info:getChildByName("icon")
        self.upgrade_star_node_item_list[i].quality = icon_info:getChildByName("quality")
        self.upgrade_star_node_item_list[i].star_shadow = icon_info:getChildByName("star_shadow")
        self.upgrade_star_node_item_list[i].star = icon_info:getChildByName("star")
        self.upgrade_star_node_item_list[i].star_spine_node = icon_info:getChildByName("star_spine_node")
        self.upgrade_star_node_item_list[i].num1 = icon_info:getChildByName("num1")
        self.upgrade_star_node_item_list[i].num2 = icon_info:getChildByName("num2")
        self.upgrade_star_node_item_list[i].camp_bg = icon_info:getChildByName("camp_bg")
        self.upgrade_star_node_item_list[i].camp_type = self.upgrade_star_node_item_list[i].camp_bg:getChildByName("icon")
        self.upgrade_star_node_item_list[i].redpoint = icon_info:getChildByName("redpoint")
        self.upgrade_star_node_item_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickUpgradeStarNodeItemBtn(i)
            end
        end)
    end

    self.skin_node = self.root_wnd:getChildByName("skin_node")
    --local title_label_bg = self.skin_node:getChildByName("title_label_bg")
    --local title_label_bg_label = title_label_bg:getChildByName("label")
    --title_label_bg_label:setString(TI18N("皮肤"))
    --local title_label_bg_desc_label_bg = title_label_bg:getChildByName("desc_label_bg")
    --local title_label_bg_desc_label_bg_label = title_label_bg_desc_label_bg:getChildByName("label")
    --title_label_bg_desc_label_bg_label:setString(TI18N("皮肤属性"))
    --title_label_bg:setContentSize(cc.size(title_label_bg_label:getContentSize().width + 23, 34))
    --title_label_bg_desc_label_bg:setPositionX(title_label_bg:getContentSize().width)
    --title_label_bg_desc_label_bg:setContentSize(cc.size(title_label_bg_desc_label_bg_label:getContentSize().width + 61,34))
    --self.skin_node_attr_bg1 = self.skin_node:getChildByName("attr_bg1")
    --self.skin_node_attr_bg2 = self.skin_node:getChildByName("attr_bg2")
    --self.skin_node_attr_con = self.skin_node:getChildByName("attr_con")
    --self.skin_node_lay_scrollview = self.skin_node:getChildByName("lay_scrollview")
    --self.skin_node_skin_shop_btn = self.skin_node:getChildByName("skin_shop_btn")
    --self.skin_node_equip_btn = self.skin_node:getChildByName("equip_btn")
    --self.skin_node_equiped_btn = self.skin_node:getChildByName("equiped_btn")
    --self.skin_node_get_btn = self.skin_node:getChildByName("get_btn")
    --self.skin_node_attr_item_list = {}
    --for i=1,4 do
    --    self.skin_node_attr_item_list[i] = self.skin_node:getChildByName(string_format("attr%s", i))
    --    self.skin_node_attr_item_list[i].icon = self.skin_node_attr_item_list[i]:getChildByName("icon")
    --    self.skin_node_attr_item_list[i].value = self.skin_node_attr_item_list[i]:getChildByName("value")
    --end
    --self.skin_node_item_list = {}
    --for i=1,3 do
    --    self.skin_node_item_list[i] = self.skin_node:getChildByName(string_format("item%s", i))
    --    self.skin_node_item_list[i].icon = self.skin_node_item_list[i]:getChildByName("icon")
    --    self.skin_node_item_list[i].name = self.skin_node_item_list[i]:getChildByName("name")
    --    self.skin_node_item_list[i].tips = self.skin_node_item_list[i]:getChildByName("tips")
    --    self.skin_node_item_list[i].select = self.skin_node_item_list[i]:getChildByName("select")
    --end

    self.library_story_node = self.root_wnd:getChildByName("library_story_node")
    self.library_story_node:setPositionX(display.getRight() - 298)
    self.library_story_node:setPositionY(display.getBottom() + 369)
    self.library_story_node:getChildByName("title"):setString(UI_TI18N(1141))
    local designation = self.library_story_node:getChildByName("designation")
    local age = self.library_story_node:getChildByName("age")
    local height_and_weight = self.library_story_node:getChildByName("height_and_weight")
    local camp = self.library_story_node:getChildByName("camp")
    designation:getChildByName("title"):setString(UI_TI18N(1143))
    age:getChildByName("title"):setString(UI_TI18N(1144))
    height_and_weight:getChildByName("title"):setString(UI_TI18N(1145))
    camp:getChildByName("title"):setString(UI_TI18N(1146))
    self.library_story_node_des1_value = designation:getChildByName("desc")
    self.library_story_node_des2_value = age:getChildByName("desc")
    self.library_story_node_des3_value = height_and_weight:getChildByName("desc")
    self.library_story_node_des4_value = camp:getChildByName("desc")
    self.library_story_node_story_list_scrollView = self.library_story_node:getChildByName("story_list_scrollView")
    self.library_story_node_chapter_desc_bg = self.library_story_node_story_list_scrollView:getChildByName("chapter_desc_bg")
    self.library_story_node_chapter_desc = createRichLabel(20, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0, 1), cc.p(15,self.library_story_node_chapter_desc_bg:getContentSize().height - 30),nil,nil,460)
    self.library_story_node_chapter_desc_bg:addChild(self.library_story_node_chapter_desc)
    self.library_story_node_story_list = {}
    for i=1,5 do
        self.library_story_node_story_list[i] = self.library_story_node_story_list_scrollView:getChildByName("story"..i)
        self.library_story_node_story_list[i].label = self.library_story_node_story_list[i]:getChildByName("label")
        self.library_story_node_story_list[i].lock_bg = self.library_story_node_story_list[i]:getChildByName("lock_bg")
        self.library_story_node_story_list[i].lock_icon = self.library_story_node_story_list[i]:getChildByName("lock_icon")
        self.library_story_node_story_list[i].redpoint = self.library_story_node_story_list[i]:getChildByName("redpoint")
        self.library_story_node_story_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickLibraryStoryNodeStoryBtn(i)
            end
        end)
    end

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end
    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.root_wnd , 1)
end

function GW_HeroDetailWindow:register_event()
    self.long_touch_type = LONG_TOUCH_INIT_TYPE
    self.info_node_lv_up_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.began then
            self.long_touch_type = LONG_TOUCH_BEGAN_TYPE
            delayRun(self.info_node_lv_up_btn_label1, 2, function ()
                self.long_touch_type = LONG_TOUCH_END_TYPE
                self:infoNodeChangeAutoLevUpStatus(true)
            end)
        elseif event_type == ccui.TouchEventType.canceled then
            doStopAllActions(self.info_node_lv_up_btn_label1)
            self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
            self:infoNodeChangeAutoLevUpStatus(false)
        elseif event_type == ccui.TouchEventType.ended then
            self:infoNodeChangeAutoLevUpStatus(false)
            if self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                doStopAllActions(self.info_node_lv_up_btn_label1)
                self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
                self:onClickInfoNodeLvUpBtn()
            elseif self.long_touch_type == LONG_TOUCH_CANCEL_TYPE then
                self:onClickInfoNodeLvUpBtn()
            elseif self.long_touch_type == LONG_TOUCH_END_TYPE then
                --事件触发了就不处理点击事件了
                self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
            end
        end
    end)
    self.info_node_lev_breach_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.began then
            self.long_touch_type = LONG_TOUCH_BEGAN_TYPE
            delayRun(self.info_node_lv_up_btn_label1, 2, function ()
                self.long_touch_type = LONG_TOUCH_END_TYPE
                self:infoNodeChangeAutoLevUpStatus(true)
            end)
        elseif event_type == ccui.TouchEventType.canceled then
            doStopAllActions(self.info_node_lv_up_btn_label1)
            self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
            self:infoNodeChangeAutoLevUpStatus(false)
        elseif event_type == ccui.TouchEventType.ended then
            self:infoNodeChangeAutoLevUpStatus(false)
            if self.long_touch_type == LONG_TOUCH_BEGAN_TYPE then
                doStopAllActions(self.info_node_lv_up_btn_label1)
                self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
                self:onClickInfoNodeLvUpBtn()
            elseif self.long_touch_type == LONG_TOUCH_CANCEL_TYPE then
                self:onClickInfoNodeLvUpBtn()
            elseif self.long_touch_type == LONG_TOUCH_END_TYPE then
                --事件触发了就不处理点击事件了
                self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
            end
        end
    end)



    registerButtonEventListener(self.top_left_hero_info.lock_btn, handler(self, self.onClickLockBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.top_left_hero_info.unlock_btn, handler(self, self.onClickLockBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.top_left_hero_info.reset_btn, handler(self, self.onClickResetBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    --registerButtonEventListener(self.share_btn, handler(self, self.onClickShareBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.comment_btn, handler(self, self.onClickCommentBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.to_left_btn, handler(self, self.onClickToLeftBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.to_right_btn, handler(self, self.onClickToRightBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    --registerButtonEventListener(self.info_node_lv_up_btn, handler(self, self.onClickInfoNodeLvUpBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    registerButtonEventListener(self.info_node_profession_label_bg_tips_btn, handler(self, self.onClickInfoNodeCareerTipsBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    registerButtonEventListener(self.equip_node_key_up_btn, function() self:onClickEquipNodeKeyUpBtn()  end ,true)
    registerButtonEventListener(self.equip_node_discharge_btn, function() self:onClickEquipNodeDischargeBtn()  end ,true)

    registerButtonEventListener(self.upgrade_star_node_upgrade_star_btn, handler(self, self.onClickUpGradeStarBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.skin_node_skin_shop_btn, handler(self, self.onClickSkinShopBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.skin_node_skin_get_btn, handler(self, self.onClickSkinGetBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.library_story_node_story1, handler(self, self.onClickStory1Btn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.library_story_node_story2, handler(self, self.onClickStory2Btn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if not self.show_list then return end
                if key == "power" or key == "match_rank" then 		--段位分
                    --self:updateRoleFc()
                elseif key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "hero_exp" then
                    self:updateTopNumWealth()
                elseif key == "lev" then 	--等级
                    self:updataExchangeRedPoint()
                end

                self:updateHeroInfo()
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.hero_exp)
            if config then
                BackpackController:getInstance():openTipsSource(true, config)
            end
        end
    end)

    ----新增英雄
    --self:addGlobalEvent(HeroEvent.Hero_Data_Add, function(list)
    --end)
    --删除英雄
    self:addGlobalEvent(HeroEvent.Del_Hero_Event, function(list)
        if self.show_list ~= nil then
            local select_hero_vo_id = self.show_list[self.index].partner_id

            if not list then return end
            local dic_parther = {}
            for i,v in ipairs(list) do
                dic_parther[v.partner_id] = true
            end

            local hero_list = {}
            for i,v in ipairs(self.show_list) do
                if not dic_parther[v.partner_id] then
                    table_insert(hero_list, v)
                    if select_hero_vo_id == v.partner_id then
                        self.index = #hero_list
                    end
                end
            end

            self.show_list = hero_list

            self:updateHeroInfo()
        end
    end)

    if self.hero_data_update_event == nil then
        self.hero_data_update_event = GlobalEvent:getInstance():Bind(HeroEvent.Hero_Data_Update, function(hero_vo)
            self:updateHeroInfo()
        end)
    end

    --英雄信息更新
    if self.hero_equip_update_event == nil then
        self.hero_equip_update_event = GlobalEvent:getInstance():Bind(HeroEvent.Equip_Update_Event, function()
            self:updateHeroInfo()
        end)
    end
    --添加英雄选择返回事件
    if self.upgrade_star_select_event == nil then
        self.upgrade_star_select_event = GlobalEvent:getInstance():Bind(HeroEvent.Upgrade_Star_Select_Event, function()
            self:updateHeroItemInfo()
        end)
    end
    --红点更新事件..英雄信息更新和 背包的信息更新 才能判断红点
    if self.hero_equip_redpoint_event == nil then
        self.hero_equip_redpoint_event = GlobalEvent:getInstance():Bind(HeroEvent.Equip_RedPoint_Event, function()
            self:updateEquipNodeRedPoint()
            self:updateEquipNodeOneKeyBtnStatus()
            self:updateSheetRedpoint()
        end)
    end

    --符文（神器）信息
    if not self.update_artifact_event then
        self.update_artifact_event = GlobalEvent:getInstance():Bind(HeroEvent.Artifact_Update_Event, function(vo)
            self:updateHeroInfo()
        end)
    end

    if self.gw_hero_story_data_update == nil then
        self.gw_hero_story_data_update = GlobalEvent:getInstance():Bind(HeroEvent.GW_Hero_Story_Data_Update, function(hero_vo)
            self:updateLibraryStoryNodeStoryRedpoint()
            self:updateSheetRedpoint()
        end)
    end

    --英雄升级失败
    if self.hero_level_up_fail == nil then
        self.hero_level_up_fail = GlobalEvent:getInstance():Bind(HeroEvent.Hero_Level_Up_Fail_Event, function()
            doStopAllActions(self.info_node_lv_up_btn_label1)
            self.long_touch_type = LONG_TOUCH_END_TYPE
            self:infoNodeChangeAutoLevUpStatus(false)
        end)
    end
    ----英雄升级成功
    --if self.hero_level_up_success == nil then
    --    self.hero_level_up_success = GlobalEvent:getInstance():Bind(HeroEvent.Hero_Level_Up_Success_Event, function()
    --    end)
    --end

    --单个英雄信息发生变化
    if self.hero_detail_data_update == nil then
        self.hero_detail_data_update = GlobalEvent:getInstance():Bind(HeroEvent.Hero_Detail_Data_Update, function(hero_vo)
            self:updateSheetRedpoint()
        end)
    end
    if self.hero_data_update == nil then
        self.hero_data_update = GlobalEvent:getInstance():Bind(HeroEvent.Hero_Data_Update, function(hero_vo)
            self:updateSheetRedpoint()
        end)
    end

    --英雄解锁事件
    self:addGlobalEvent(HeroEvent.Hero_Lock_Event, function()
        if not self.index or not self.show_list then return end
        local hero_info = self.show_list[self.index]
        if not hero_info then return end
        if hero_info.dic_locks[HeroConst.LockType.eHeroLock] and
                hero_info.dic_locks[HeroConst.LockType.eHeroLock] == 1 then
            self.top_left_hero_info.lock_btn:setVisible(false)
            self.top_left_hero_info.unlock_btn:setVisible(true)
        else
            self.top_left_hero_info.lock_btn:setVisible(true)
            self.top_left_hero_info.unlock_btn:setVisible(false)
        end
    end)

    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end
end

function GW_HeroDetailWindow:infoNodeChangeAutoLevUpStatus(is_in_auto_lev_up)
    if is_in_auto_lev_up == self.is_in_auto_lev_up then return end
    self.is_in_auto_lev_up =  is_in_auto_lev_up
    if self.is_in_auto_lev_up == true then
        if self.auto_time_ticket == nil then
            self.auto_time_ticket = GlobalTimeTicket:getInstance():add(function()
                if self.is_in_auto_lev_up == true then
                    self:onClickInfoNodeLvUpBtn()
                else
                    self:clearAutoTimeticket()
                end
            end, 0.5)
        end
    else
        self:clearAutoTimeticket()
    end
end
function GW_HeroDetailWindow:clearAutoTimeticket()
    if self.auto_time_ticket then
        GlobalTimeTicket:getInstance():remove(self.auto_time_ticket)
        self.auto_time_ticket = nil
    end
end

function GW_HeroDetailWindow:close_callback()
    doStopAllActions(self.background)
    doStopAllActions(self.hero_draw_node)
    doStopAllActions(self.hero_spine_node)
    doStopAllActions(self.hero_spine_node)
    doStopAllActions(self.info_node_lv_up_btn_label1)
    self:clearAutoTimeticket()

    if self.info_node_attr_num_timer then
        GlobalTimeTicket:getInstance():remove(self.info_node_attr_num_timer)
        self.info_node_attr_num_timer = nil
    end

    self.last_hp = nil
    self.last_def = nil
    self.last_atk = nil
    self.last_speed = nil
    self.num_change_flag = false
    if self.info_node_hp_attr_spine ~= nil then
        self.info_node_hp_attr_spine:clearTracks()
        self.info_node_hp_attr_spine:removeFromParent()
        self.info_node_hp_attr_spine = nil
    end
    if self.info_node_def_attr_spine ~= nil then
        self.info_node_def_attr_spine:clearTracks()
        self.info_node_def_attr_spine:removeFromParent()
        self.info_node_def_attr_spine = nil
    end
    if self.info_node_atk_attr_spine ~= nil then
        self.info_node_atk_attr_spine:clearTracks()
        self.info_node_atk_attr_spine:removeFromParent()
        self.info_node_atk_attr_spine = nil
    end
    if self.info_node_speed_attr_spine ~= nil then
        self.info_node_speed_attr_spine:clearTracks()
        self.info_node_speed_attr_spine:removeFromParent()
        self.info_node_speed_attr_spine = nil
    end

    self.break_effect_flag = false
    self.last_break_count = nil
    if self.break_effect_spine ~= nil then
        self.break_effect_spine:clearTracks()
        self.break_effect_spine:removeFromParent()
        self.break_effect_spine = nil
    end

    if self.top_left_hero_info.star_spine ~= nil then
        self.top_left_hero_info.star_spine:clearTracks()
        self.top_left_hero_info.star_spine:removeFromParent()
        self.top_left_hero_info.star_spine = nil
    end

    if self.sheet_btn_list then
        for i,sheet in pairs(self.sheet_btn_list) do
            if sheet.red_point_spine ~= nil then
                sheet.red_point_spine:setVisible(false)
                sheet.red_point_spine:removeFromParent()
                sheet.red_point_spine = nil
            end
            if sheet.spine then
                sheet.spine:clearTracks()
                sheet.spine:removeFromParent()
                sheet.spine = nil
            end
        end
        self.sheet_btn_list = nil
    end
    if self.info_node_lv_up_btn_redpoint_spine ~= nil then
        self.info_node_lv_up_btn_redpoint_spine:setVisible(false)
        self.info_node_lv_up_btn_redpoint_spine:removeFromParent()
        self.info_node_lv_up_btn_redpoint_spine = nil
    end
    if self.info_node_lev_breach_btn_redpoint_spine ~= nil then
        self.info_node_lev_breach_btn_redpoint_spine:setVisible(false)
        self.info_node_lev_breach_btn_redpoint_spine:removeFromParent()
        self.info_node_lev_breach_btn_redpoint_spine = nil
    end

    if self.info_node_battle_info_spine ~= nil then
        self.info_node_battle_info_spine:setVisible(false)
        self.info_node_battle_info_spine:removeFromParent()
        self.info_node_battle_info_spine = nil
    end
    if self.equip_node_list then
        for i,v in pairs(self.equip_node_list) do
            if v.redpoint_spine ~= nil then
                v.redpoint_spine:setVisible(false)
                v.redpoint_spine:removeFromParent()
                v.redpoint_spine = nil
            end
        end
        self.equip_node_list = nil
    end
    if self.equip_node_key_up_btn_redpoint_spine ~= nil then
        self.equip_node_key_up_btn_redpoint_spine:setVisible(false)
        self.equip_node_key_up_btn_redpoint_spine:removeFromParent()
        self.equip_node_key_up_btn_redpoint_spine = nil
    end

    for i,v in pairs(self.library_story_node_story_list) do
        if v.redpoint_spine ~= nil then
            v.redpoint_spine:setVisible(false)
            v.redpoint_spine:removeFromParent()
            v.redpoint_spine = nil
        end
    end

    if self.background_spine then
        self.background_spine:clearTracks()
        self.background_spine:removeFromParent()
        self.background_spine = nil
    end
    if self.screen_spine then
        self.screen_spine:clearTracks()
        self.screen_spine:removeFromParent()
        self.screen_spine = nil
    end

    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
    self.hero_draw_node_moving = false

    if self.camp_type_totem_load then
        self.camp_type_totem_load:DeleteMe()
        self.camp_type_totem_load = nil
    end

    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end
    --role_vo = nil

    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end

    if self.hero_draw_load then
        self.hero_draw_load:DeleteMe()
        self.hero_draw_load = nil
    end
    if self.spine then
        self.spine:setVisible(false)
        self.spine:removeFromParent()
        self.spine = nil
    end

    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end

    self.show_list = nil
    self.top_num_wealth_list = nil
    self:DeleteMe()

    self.ctrl:closeHeroDetailView()
end

--移除事件监听
function GW_HeroDetailWindow:DeleteMe()
    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end
    --role_vo = nil
    self.top_num_wealth_list = nil
    if self.hero_data_update_event then
        GlobalEvent:getInstance():UnBind(self.hero_data_update_event)
        self.hero_data_update_event = nil
    end
    if self.hero_equip_update_event then
        GlobalEvent:getInstance():UnBind(self.hero_equip_update_event)
        self.hero_equip_update_event = nil
    end
    if self.upgrade_star_select_event then
        GlobalEvent:getInstance():UnBind(self.upgrade_star_select_event)
        self.upgrade_star_select_event = nil
        end
    if self.hero_equip_redpoint_event then
        GlobalEvent:getInstance():UnBind(self.hero_equip_redpoint_event)
        self.hero_equip_redpoint_event = nil
    end
    if self.update_artifact_event then
        GlobalEvent:getInstance():UnBind(self.update_artifact_event)
        self.update_artifact_event = nil
    end

    if self.gw_hero_story_data_update then
        GlobalEvent:getInstance():UnBind(self.gw_hero_story_data_update)
        self.gw_hero_story_data_update = nil
    end

    if self.hero_level_up_fail then
        GlobalEvent:getInstance():UnBind(self.hero_level_up_fail)
        self.hero_level_up_fail = nil
    end
    if self.hero_detail_data_update then
        GlobalEvent:getInstance():UnBind(self.hero_detail_data_update)
        self.hero_detail_data_update = nil
    end
    if self.hero_data_update then
        GlobalEvent:getInstance():UnBind(self.hero_data_update)
        self.hero_data_update = nil
    end


    if self.upgrade_star_node_item_list then
        for i,v in ipairs(self.upgrade_star_node_item_list) do
            if v.star_spine then
                v.star_spine:clearTracks()
                v.star_spine:removeFromParent()
                v.star_spine = nil
            end
            if v.redpoint_spine then
                v.redpoint_spine:clearTracks()
                v.redpoint_spine:removeFromParent()
                v.redpoint_spine = nil
            end
        end
        self.upgrade_star_node_item_list = nil
    end
    if self.upgrade_star_node_upgrade_star_btn_redpoint_spine ~= nil then
        self.upgrade_star_node_upgrade_star_btn_redpoint_spine:clearTracks()
        self.upgrade_star_node_upgrade_star_btn_redpoint_spine:removeFromParent()
        self.upgrade_star_node_upgrade_star_btn_redpoint_spine = nil
    end
end

--分享
function GW_HeroDetailWindow:onClickShareBtn(force)
end
--评论
function GW_HeroDetailWindow:onClickCommentBtn(force)
end
--点击下方页签
function GW_HeroDetailWindow:onClickSheetBtn(sheet_type)
    if self.sheet_type == sheet_type then
        return
    end
    if self.break_effect_flag == true or self.num_change_flag == true then
        return
    end
    self.last_hp = nil
    self.last_def = nil
    self.last_atk = nil
    self.last_speed = nil
    self.num_change_flag = false
    self.break_effect_flag = false
    self.last_break_count = nil

    if sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.Skin then
        FunctionNotOpenTips()
        return
    end

    self.sheet_type = sheet_type

    self:setSheetTypeUI()
end
--点击信息页签技能图标
function GW_HeroDetailWindow:onClickInfoNodeSkillBtn(skill_bid, is_lock)
    if skill_bid == nil then
        return
    end

    local config = Config.SkillData.data_get_skill(skill_bid)
    if config then
        TipsManager:getInstance():showSkillTips(config, is_lock, false, false, 0, 0)
    end
end
--点击英雄锁定或解锁
function GW_HeroDetailWindow:onClickLockBtn(force)
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    if not hero_info then return end

    local is_lock = hero_info.dic_locks[HeroConst.LockType.eHeroLock] or 0
    if is_lock == 1 then
        is_lock = 0
    else
        is_lock = 1
    end
    controller:sender11015(hero_info.partner_id, is_lock)
end
--点击英雄重生按钮
function GW_HeroDetailWindow:onClickResetBtn()
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    if not hero_info then return end

    --重生信息没有回来也忽视
    if not hero_info:isResetTimeInfo() then return end

    controller:openHeroResetComfirmPanel(true, hero_info)
end
--更新重生信息
function GW_HeroDetailWindow:updateResetInfo()
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    if not hero_info then return end

    --满足条件  不能是水晶英雄 也不能是 赋能英雄
    if (hero_info.lev > 1 and hero_info.lev <= self.born_limit_lev) and
            (hero_info.isResonateHero and not hero_info:isResonateHero()) and
            (hero_info.isResonateCrystalHero and not hero_info:isResonateCrystalHero()) then
        self:sendRssetTimeProto()
        self.top_left_hero_info.reset_btn:setVisible(true)
    else
        self.top_left_hero_info.reset_btn:setVisible(false)
    end
end
function GW_HeroDetailWindow:sendRssetTimeProto(  )
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    if not hero_info then return end

    if hero_info.isResetTimeInfo and not hero_info:isResetTimeInfo() then
        controller:sender11067(hero_info.partner_id)
    end
end
--前一个
function GW_HeroDetailWindow:onClickToLeftBtn(force)
    if self.hero_draw_node_moving == true then
        return
    end

    if self.break_effect_flag == true or self.num_change_flag == true then
        return
    end

    self.last_hp = nil
    self.last_def = nil
    self.last_atk = nil
    self.last_speed = nil
    self.num_change_flag = false
    self.break_effect_flag = false
    self.last_break_count = nil

    self.hero_draw_node_moving = true

    doStopAllActions(self.hero_draw_node)
    doStopAllActions(self.hero_spine_node)
    self.hero_draw_node:setPositionX(self.hero_draw_node_pos_x)
    self.hero_spine_node:setPositionX(self.hero_spine_node_pos_x)

    if self.index > 1 then
        self.index = self.index - 1
    else
        self.index = 1
    end
    self:updateHeroInfo()

    --播放窗口动画
    self:playEnterAnimatianByObj(self.hero_draw_node , 1)
    self:playEnterAnimatianByObj(self.hero_spine_node , 1)

    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
    self.time_ticket = GlobalTimeTicket:getInstance():add(function()
        if self.time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.time_ticket)
            self.time_ticket = nil
        end
        self.hero_draw_node_moving = false
    end, 0.15)
end
--后一个
function GW_HeroDetailWindow:onClickToRightBtn(force)
    if self.hero_draw_node_moving == true then
        return
    end

    if self.break_effect_flag == true or self.num_change_flag == true then
        return
    end

    self.last_hp = nil
    self.last_def = nil
    self.last_atk = nil
    self.last_speed = nil
    self.num_change_flag = false
    self.break_effect_flag = false
    self.last_break_count = nil

    self.hero_draw_node_moving = true

    doStopAllActions(self.hero_draw_node)
    doStopAllActions(self.hero_spine_node)
    self.hero_draw_node:setPositionX(self.hero_draw_node_pos_x)
    self.hero_spine_node:setPositionX(self.hero_spine_node_pos_x)

    if self.index < #self.show_list then
        self.index = self.index + 1
    else
        self.index = #self.show_list
    end
    self:updateHeroInfo()

    --播放窗口动画
    self:playEnterAnimatianByObj(self.hero_draw_node , 3)
    self:playEnterAnimatianByObj(self.hero_spine_node , 3)

    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
    self.time_ticket = GlobalTimeTicket:getInstance():add(function()
        if self.time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.time_ticket)
            self.time_ticket = nil
        end
        self.hero_draw_node_moving = false
    end, 0.15)
end
--请求升级
function GW_HeroDetailWindow:onClickInfoNodeLvUpBtn(force)
    if not self.index or not self.show_list then return end

    --if self.break_effect_flag == true or self.num_change_flag == true then
    --    return
    --end

    local hero_vo = self.show_list[self.index]
    local status = HeroCalculate.getHeroShowLevelStatus(hero_vo)
    if status == 1 then
        --if self.is_send_level then
        --    return
        --end
        --self.is_send_level = true
        ----升级
        --self.is_update_hero_info = false
        --self.is_update_res_info = false
        controller:sender11003(hero_vo.id)
    elseif status == 2 then
        --可以进阶了
        controller:openHeroBreakPanel(true, hero_vo)

        doStopAllActions(self.info_node_lv_up_btn_label1)
        self.long_touch_type = LONG_TOUCH_END_TYPE
        self:infoNodeChangeAutoLevUpStatus(false)
    end
end
--查看职业详情
function GW_HeroDetailWindow:onClickInfoNodeCareerTipsBtn(force)
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    controller:openHeroTipsAttrPanel(true, hero_info, true)
end
--一键穿戴装备
function GW_HeroDetailWindow:onClickEquipNodeKeyUpBtn(force)
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]

    --按钮的红点
    local is_btn_redpoint = false
    --装备红点
    for i=1,4 do
        local equip_type = HeroConst.EquipPosList[i]
        local is_redpoint = self:updateEquipNodeEachEquipRedPoint(equip_type, hero_vo)
        if not is_btn_redpoint and is_redpoint == true then
            is_btn_redpoint = is_redpoint
            break
        end
    end

    if not is_btn_redpoint then
        message(UI_TI18N(1123))
        return
    end

    controller:sender11010(hero_vo.partner_id, 0)
end
--一键卸下装备
function GW_HeroDetailWindow:onClickEquipNodeDischargeBtn(force)
    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]
    controller:sender11011(hero_info.partner_id, 0)
end
--装备页面-选择装备
function GW_HeroDetailWindow:onClickEquipNodeSelectEquipByIndex(index)
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]
    if not hero_vo then return end

    if index == 5 or index == 6 then
        --5 ,6 是符文的位置
        local pos = index - 4
        local equip_vo = hero_vo.artifact_list[pos]
        --策划要求 原本 6星解锁 改成 7星解锁 .原本6星的已有数据的保留
        if equip_vo == nil then
            local artifact_lock = self.artifact_lock_list[pos]
            if artifact_lock then
                if artifact_lock[1] == 'lev' then
                    if hero_vo.lev < artifact_lock[2] then
                        message(string_format( UI_TI18N(1124),artifact_lock[2]))
                        return
                    end
                elseif artifact_lock[1] == 'star' then
                    if hero_vo.star < artifact_lock[2] then
                        message(string_format( UI_TI18N(1125),artifact_lock[2]))
                        return
                    end
                end
            end
        end

        --默认都是主符文
        if equip_vo and next(equip_vo) ~=nil then
            controller:openArtifactTipsWindow(true, equip_vo, PartnerConst.ArtifactTips.partner, hero_vo.partner_id, pos, self.lock_list[pos])
        else
            controller:openArtifactListWindow(true, pos, hero_vo.partner_id)
        end
    elseif index == 7 then
        --7魂器位置，功能待定
        FunctionNotOpenTips()
    else
        local equip_type = index
        local equip_list = model:getHeroEquipList(hero_vo.partner_id)
        local equip_vo = equip_list[equip_type]
        if equip_vo ~= nil then
            controller:openEquipTips(true, equip_vo, PartnerConst.EqmTips.partner, hero_vo)
        else
            controller:openEquipPanel(true,equip_type,hero_vo.partner_id)
        end
    end
end
--升星页面-升星
function GW_HeroDetailWindow:onClickUpGradeStarBtn(force)
    if self.is_max_star then
        for i=1,4 do
            self.upgrade_star_node_item_list[i]:setVisible(false)
        end
        self.upgrade_star_node_consume_coin_bg:setVisible(false)
        self.upgrade_star_node_upgrade_star_btn:setVisible(false)
        Debug.error("该英雄已满星")
        return
    end

    if not self.index or not self.show_list then return end
    self.hero_vo = self.show_list[self.index]
    if not self.hero_vo then return end

    if self.hero_item_data_list and next(self.hero_item_data_list) ~= nil then
        local partner_id = self.hero_vo.partner_id
        local hero_list = {}
        local random_list = {}
        local dic_item_expend = {}
        for i,item in ipairs(self.hero_item_data_list) do
            local count = 0
            for k,v in pairs(item.dic_select_list) do
                count = count + 1
            end
            if count < item.count then
                message(UI_TI18N(1137))
                return
            end
            for k,v in pairs(item.dic_select_list) do
                if v.is_hero_hun then --是否英魂 参考 HeroUpgradeStarSelectPanel:initHeroList(dic_other_selected) 里面的定义
                    if v.good_vo then
                        if dic_item_expend[v.good_vo.base_id] == nil then
                            dic_item_expend[v.good_vo.base_id] = 1
                        else
                            dic_item_expend[v.good_vo.base_id] = dic_item_expend[v.good_vo.base_id] + 1
                        end
                    end
                else
                    local data = {}
                    data.partner_id = k
                    if item.bid == 0 then
                        --随机卡
                        table_insert(random_list, data)
                    else
                        --指定卡
                        table_insert(hero_list, data)
                    end
                end
            end
        end
        model:setUpgradeStarUpdateRecord(false)
        self.is_hero_data_update = false
        self.is_del_hero_event = false

        local item_list = {}
        for item_id, num in pairs(dic_item_expend) do
            local data = {}
            data.item_id = item_id
            data.num = num
            table_insert(item_list, data)
        end
        controller:sender11005(partner_id, hero_list, random_list, item_list)
    end
end

--传记页面-点击故事
function GW_HeroDetailWindow:onClickLibraryStoryNodeStoryBtn(index)
    if self.library_story_node_story_list[index].story_id == nil then
        return
    end

    GW_HeroBagController:getInstance():openHeroStoryView(self.hero_vo, self.library_story_node_story_list[index].story_id)
end
--打开皮肤商城
function GW_HeroDetailWindow:onClickSkinShopBtn(force)
    local role_vo = RoleController:getInstance():getRoleVo()
    local limit_cfg = Config.ChargeMallData.data_const["skin_mall_lev"]
    if limit_cfg and limit_cfg.val > role_vo.lev then
        message(limit_cfg.desc)
        return
    end

    MallController:getInstance():openSkinShopWindow(true)
end
--获取皮肤
function GW_HeroDetailWindow:onClickSkinGetBtn(force)
    if not self.select_skin_index then return end
    if not self.skin_data_list then return end
    local skin_data = self.skin_data_list[self.select_skin_index]
    if not skin_data then return end

    self:setSkinLockInfo(skin_data, self.select_skin_index)
end

function GW_HeroDetailWindow:setSkinLockInfo(skin_data, index)
    local dic_item_id = {}
    for i,id in ipairs(skin_data.config.item_id_list) do
        dic_item_id[id] = true
    end

    local have_item = nil
    local have_list = {}
    local list = BackpackController:getInstance():getModel():getBagItemList(BackPackConst.Bag_Code.BACKPACK) or {}
    for i,item in pairs(list) do
        if item.config and dic_item_id[item.config.id] then
            --背包上有道具
            local data = {}

            if item.config.client_effect[1] and item.config.client_effect[1][2] then
                data.time = item.config.client_effect[1][2]
            else
                data.time = 1
            end
            if data.time == 0 then
                --表示有永久的皮肤
                have_item = item
                break
            end
            data.item_info = item
            table_insert(have_list, data)
        end
    end
    if have_item then
        --表示有永久的皮肤
        --self:useSkinItemByID(have_item, index)
        return
    end
    if #have_list > 0 then
        --table.sort(have_list, function(a, b) return a.time > b.time end)
        --self:useSkinItemByID(have_list[1].item_info, index)
    else
        --判断是否有活动id 有直接跳转
        if self:checkValidActionTime(skin_data.config) then
            self:gotoSkinAction(skin_data.config)
            return
        end

        --说明该皮肤不能同商城获取
        if skin_data.config.is_shop == 0 then
            message(TI18N("暂未获取此皮肤，请前往相关活动或玩法中获取！"))
        else
            self:gotoSkinAction(skin_data.config)
        end

    end
end

function GW_HeroDetailWindow:checkValidActionTime(config)
    if self.is_check_action_time ~= nil then
        return self.is_check_action_time
    end

    self.is_check_action_time = false
    if config and config.action_bid ~= 0 then
        local start_time = 0
        local end_time = 0
        if next(config.action_start_time) ~= nil and next(config.action_end_time) ~= nil then
            local year  = config.action_start_time[1] or 0
            local month = config.action_start_time[2] or 0
            local day   = config.action_start_time[3] or 0
            local hour  = config.action_start_time[4] or 0
            local min   = config.action_start_time[5] or 0
            local sec   = config.action_start_time[6] or 0
            start_time  =  os.time{year = year, month = month, day = day, hour = hour, min = min, sec = sec}
            year  = config.action_end_time[1] or 0
            month = config.action_end_time[2] or 0
            day   = config.action_end_time[3] or 0
            hour  = config.action_end_time[4] or 0
            min   = config.action_end_time[5] or 0
            sec   = config.action_end_time[6] or 0
            end_time  =  os.time{year = year, month = month, day = day, hour = hour, min = min, sec = sec}
        end

        if start_time ~= 0 and end_time ~= 0 then
            local cur_time = GameNet:getInstance():getTime()
            if cur_time >= start_time and cur_time <= end_time then
                self.is_check_action_time = true
            end
        else
            self.is_check_action_time = true
        end

        if self.is_check_action_time then
            --是否存在 活动
            self.is_check_action_time = ActionController:getInstance():CheckActionExistByActionBid(config.action_bid)
        end
    end
    return self.is_check_action_time
end

--跳转活动id
function GW_HeroDetailWindow:gotoSkinAction(config)
    local callback = function()
        --优先找皮肤活动
        if self:checkValidActionTime(config) then
            ActionController:getInstance():openActionMainPanel(true, nil, config.action_bid)
            return
        end

        --没有皮肤活动 找活动商城
        local shop_config = Config.ExchangeData.data_shop_list[MallConst.MallType.HeroSkin]
        if shop_config and shop_config.sort ~= 0 then
            MallController:getInstance():openMallPanel(true, MallConst.MallType.HeroSkin)
            return
        end

        --没有活动商城 提示:
        message(TI18N("暂无该皮肤获取途径"))
    end

    local str = TI18N("当前暂未拥有该皮肤,是否前往获取？")
    CommonAlert.show(str, TI18N("确定"), callback, TI18N("取消"),nil, nil, nil, {title = TI18N("解锁皮肤")})
end

--打开故事1
function GW_HeroDetailWindow:onClickStory1Btn(force)
    if self.library_config ~= nil then
        GW_HeroLibraryStoryDetailController:getInstance():openHeroLibraryStoryDetailView(self.library_config.bid, 1)
    end
end
--打开故事2
function GW_HeroDetailWindow:onClickStory2Btn(force)
    if self.library_config ~= nil then
        GW_HeroLibraryStoryDetailController:getInstance():openHeroLibraryStoryDetailView(self.library_config.bid, 2)
    end
end

--根据页签类型刷新页签
function GW_HeroDetailWindow:setSheetTypeUI()
    doStopAllActions(self.info_node_lv_up_btn_label1)
    self.long_touch_type = LONG_TOUCH_CANCEL_TYPE
    self:infoNodeChangeAutoLevUpStatus(false)

    self.info_node:setVisible(self.sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.Info)
    self.equip_node:setVisible(self.sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.Equip)
    self.upgrade_star_node:setVisible(self.sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.UpgradeStar)
    self.skin_node:setVisible(self.sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.Skin)
    self.library_story_node:setVisible(self.sheet_type == GW_HeroBagConst.Hero_Detail_Sheet_Type.LibraryStory)

    for i=1,5 do
        self.sheet_btn_list[i].normal:setVisible(true)
        self.sheet_btn_list[i].select:setVisible(false)
        self.sheet_btn_list[i].spine_flag = false
    end
    self.sheet_btn_list[self.sheet_type + 1].normal:setVisible(false)
    self.sheet_btn_list[self.sheet_type + 1].select:setVisible(true)

    self.sheet_btn_list[self.sheet_type + 1].spine_flag = true
    self.sheet_btn_list[self.sheet_type + 1].spine:setAnimation(0, "anniu_xuanzhong", false)

    self:updateHeroInfo()
    self:updateTopNumWealth()
end

function GW_HeroDetailWindow:updateHeroInfo()
    if not self.top_num_wealth_list then return end

    if not self.index or not self.show_list then return end
    local hero_info = self.show_list[self.index]

    if hero_info.dic_locks[HeroConst.LockType.eHeroLock] and
            hero_info.dic_locks[HeroConst.LockType.eHeroLock] == 1 then
        self.top_left_hero_info.lock_btn:setVisible(false)
        self.top_left_hero_info.unlock_btn:setVisible(true)
    else
        self.top_left_hero_info.lock_btn:setVisible(true)
        self.top_left_hero_info.unlock_btn:setVisible(false)
    end

    local hero_base_config = Config.PartnerData.data_partner_base_fun(hero_info.bid)
    local key = getNorKey(hero_info.bid, hero_info.star or 1)
    local hero_star_config = Config.PartnerData.data_partner_star(key)

    local camp_type_totem_res_id = PathTool.getPlistImgForDownLoad("gw_partnersummon/shipment_icons",hero_base_config.shipment_icon_id,false)
    if self.camp_type_totem_res_id ~= camp_type_totem_res_id then
        self.camp_type_totem_res_id = camp_type_totem_res_id
        if self.camp_type_totem_load then
            self.camp_type_totem_load:DeleteMe()
            self.camp_type_totem_load = nil
        end

        if not self.camp_type_totem_load then
            self.camp_type_totem_load = loadSpriteTextureFromCDN(self.hero_shipment, camp_type_totem_res_id, ResourcesType.single, self.camp_type_totem_load)
        end
    end

    local res = PathTool.getPlistImgForDownLoad("herodraw/herodrawres", hero_base_config.draw_res)
    if self.hero_draw_res_id == nil or self.hero_draw_res_id ~= res then
        self.hero_draw_res_id = res
        if self.hero_draw_load then
            self.hero_draw_load:DeleteMe()
            self.hero_draw_load = nil
        end
        self.hero_draw_load = loadSpriteTextureFromCDN(self.hero_draw, self.hero_draw_res_id, ResourcesType.single, self.hero_draw_load, 0,function()
            self.hero_draw:setPositionX(hero_base_config.draw_offset[1])
            self.hero_draw:setPositionY(hero_base_config.draw_offset[2])
            self.hero_draw_node:setScale(hero_base_config.draw_scale/100)
        end)
    end
    if self.spine_res_id == nil or self.spine_res_id ~= hero_star_config.res_id or self.spine_skin_res_id == nil or self.spine_skin_res_id ~= hero_star_config.skin then
        local spine_scale = 1
        local offset_x = 0
        local offset_y = 0
        local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(hero_info.bid)
        if spine_scale_config then
            spine_scale = spine_scale_config.show_scale/1000
            offset_x = spine_scale_config.show_coordinate[1]
            offset_y = spine_scale_config.show_coordinate[2]
        end
        self.spine_res_id = hero_star_config.res_id
        self.spine_skin_res_id = hero_star_config.skin
        if self.spine then
            self.spine:setVisible(false)
            self.spine:removeFromParent()
            self.spine = nil
        end
        self.spine = gw_createEffectSpine(self.spine_res_id, cc.p(0+offset_x,0+offset_y) , cc.p(0.5,0),true,PlayerAction.gw_idle,nil,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
        setSpineSkin(self.spine, self.spine_skin_res_id)
        self.spine:setScale(spine_scale)
        self.hero_spine_node_spine_node:addChild(self.spine)
        --local scale = 1
        --if hero_star_config.partner_scalc then
        --    scale = hero_star_config.partner_scalc/1000
        --end
        --self.spine:setScale(scale)
    end
    loadSpriteTexture(self.hero_spine_node_camp, PathTool.gw_getCampTypeCornerCommon01(hero_info.camp_type), LOADTEXT_TYPE_PLIST)


    self.to_left_btn:setVisible(self.index > 1)
    self.to_right_btn:setVisible(self.index < #self.show_list)
    --self.battle_label:setString(hero_info.power)

    --刷新左上角英雄信息
    loadSpriteTexture(self.top_left_hero_info.camp_type, PathTool.gw_getCampTypeCommon01(hero_info.camp_type), LOADTEXT_TYPE_PLIST)
    self.top_left_hero_info.name:setString(hero_info.name)
    if hero_info.star < 6 then
        self.top_left_hero_info.star:setPositionX(-109)
        self.top_left_hero_info.star:setPositionY(-23)
        self.top_left_hero_info.star:setScale(1)
        loadSpriteTexture(self.top_left_hero_info.star, PathTool.gw_getStarCommon01(hero_info.star), LOADTEXT_TYPE_PLIST)
        self.top_left_hero_info.star:setVisible(true)
        self.top_left_hero_info.star_spine_node:setVisible(false)
    elseif hero_info.star < 10 then
        self.top_left_hero_info.star:setPositionX(-109)
        self.top_left_hero_info.star:setPositionY(-23)
        self.top_left_hero_info.star:setScale(1)
        loadSpriteTexture(self.top_left_hero_info.star, PathTool.gw_getStarCommon01(hero_info.star), LOADTEXT_TYPE_PLIST)
        self.top_left_hero_info.star:setVisible(true)
        self.top_left_hero_info.star_spine_node:setVisible(false)
    else
        if self.top_left_hero_info.star_spine == nil then
            self.top_left_hero_info.star_spine = gw_createEffectSpine("E90121", cc.p(0, 0), cc.p(0.5, 0.5), true, "kapian_xingsaoguang")
            self.top_left_hero_info.star_spine_node:addChild(self.top_left_hero_info.star_spine)
        end
        self.top_left_hero_info.star:setVisible(false)
        self.top_left_hero_info.star_spine_node:setVisible(true)
    end

    --dump(hero_info, "********* hero_info *********")
    --Debug.info(hero_info)
    --刷新信息页面
    self:updateInfoNode(hero_info)
    --刷新装备页面
    self:updateEquipNode(hero_info)
    --刷新升星页面
    self:updateUpgradeStarNode(hero_info)
    ----刷新皮肤页面
    --self:updateSkinNode(hero_info)
    --刷新传记页面
    self:updateLibraryStoryNode(hero_info)

    --刷新页签红点
    self:updateSheetRedpoint()

    --重生
    self:updateResetInfo()
end

--刷新信息页面
function GW_HeroDetailWindow:updateInfoNode(hero_info)
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.Info then
        return
    end

    local break_lev = hero_info.break_lev
    local lev = hero_info.lev
    local key = getNorKey(hero_info.type, hero_info.break_id, break_lev)
    local break_config = Config.PartnerData.data_partner_brach[key]
    local next_key = getNorKey(hero_info.type, hero_info.break_id, break_lev + 1)
    local next_break_config = Config.PartnerData.data_partner_brach[next_key]

    local key = getNorKey(hero_info.bid, hero_info.star)
    local star_config = Config.PartnerData.data_partner_star(key)
    if star_config == nil then
        Debug.log(string_format("找不到英雄星级配置!!bid:%s  star:%s", hero_info.bid, hero_info.star))
    end

    self.info_node_lv_max_btn:setVisible(false)
    self.info_node_lv_up_btn:setVisible(false)
    self.info_node_lev_breach_btn:setVisible(false)

    --上限等级
    local lev_max = break_config.lev_max
    self.limit_lev_max = lev_max
    if next_break_config == nil then
        if star_config and lev_max < star_config.lev_max then
            lev_max = star_config.lev_max
            self.limit_lev_max = lev_max
        end

        if lev >= lev_max then
            self.info_node_lv_max_btn:setVisible(true)
            ---- 都满了  满级状态
            --self.info_node_lv_up_btn_label2:setString(UI_TI18N(1116))
            --self.info_node_lv_up_btn_label2:setPositionX(self.info_node_lv_up_btn_label1:getPositionX())
            --self.info_node_lv_up_btn_label1:setVisible(false)
            --setChildUnEnabled(true, self.info_node_lv_up_btn)
            --self.info_node_lv_up_btn:setTouchEnabled(false)
            --self.info_node_lv_up_btn:setVisible(true)
            ----self.info_node_lv_up_btn:setVisible(false)

            for i,lv_consume in ipairs(self.info_node_lv_consume) do
                lv_consume.icon:setVisible(false)
                lv_consume.num:setVisible(false)
                if lv_consume.line then
                    lv_consume.line:setVisible(false)
                end
            end
        else
            --等级不足 需要升级
            setChildUnEnabled(false, self.info_node_lv_up_btn)
            self.info_node_lv_up_btn:setTouchEnabled(true)
            self.info_node_lv_up_btn:setVisible(true)
            self:updateInfoNodeCostInfo(hero_info)
        end
    else
        if next_break_config.limit and next(next_break_config.limit) ~= nil then
            if lev >= break_config.lev_max then
                --进阶有要求 需要升星
                local is_enough = HeroCalculate.isEnoughCondition(next_break_config.limit, hero_info)
                if is_enough then
                    --可以进阶了
                    --setChildUnEnabled(false, self.info_node_lv_up_btn)
                    --self.info_node_lv_up_btn:setTouchEnabled(true)
                    --self.info_node_lv_up_btn:setVisible(true)
                    --self.info_node_lv_up_btn_label2:setString(UI_TI18N(1113))
                    --self.info_node_lv_up_btn_label2:setPositionX(self.info_node_lv_up_btn_label1:getPositionX())
                    --self.info_node_lv_up_btn_label1:setVisible(false)
                    self.info_node_lev_breach_btn:setVisible(true)

                    for i,lv_consume in ipairs(self.info_node_lv_consume) do
                        lv_consume.icon:setVisible(false)
                        lv_consume.num:setVisible(false)
                        if lv_consume.line then
                            lv_consume.line:setVisible(false)
                        end
                    end
                else
                    --不满足条件.显示满级状态
                    self.info_node_lv_max_btn:setVisible(true)
                    --self.info_node_lv_up_btn_label2:setString(UI_TI18N(1116))
                    --self.info_node_lv_up_btn_label2:setPositionX(self.info_node_lv_up_btn_label1:getPositionX())
                    --self.info_node_lv_up_btn_label1:setVisible(false)
                    --setChildUnEnabled(true, self.info_node_lv_up_btn)
                    --self.info_node_lv_up_btn:setTouchEnabled(false)
                    --self.info_node_lv_up_btn:setVisible(true)
                    ----self.info_node_lv_up_btn:setVisible(false)

                    for i,lv_consume in ipairs(self.info_node_lv_consume) do
                        lv_consume.icon:setVisible(false)
                        lv_consume.num:setVisible(false)
                        if lv_consume.line then
                            lv_consume.line:setVisible(false)
                        end
                    end
                end
            else
                --等级不足 需要升级
                setChildUnEnabled(false, self.info_node_lv_up_btn)
                self.info_node_lv_up_btn:setTouchEnabled(true)
                self.info_node_lv_up_btn:setVisible(true)
                self:updateInfoNodeCostInfo(hero_info)
            end
        else
            --没有限制
            setChildUnEnabled(false, self.info_node_lv_up_btn)
            if lev >= break_config.lev_max then
                self.info_node_lev_breach_btn:setVisible(true)
                --可以进阶了
                --self.info_node_lv_up_btn_label2:setString(UI_TI18N(1113))
                --self.info_node_lv_up_btn_label2:setPositionX(self.info_node_lv_up_btn_label1:getPositionX())
                --self.info_node_lv_up_btn_label1:setVisible(false)

                for i,lv_consume in ipairs(self.info_node_lv_consume) do
                    lv_consume.icon:setVisible(false)
                    lv_consume.num:setVisible(false)
                    if lv_consume.line then
                        lv_consume.line:setVisible(false)
                    end
                end
            else
                self.info_node_lv_up_btn:setTouchEnabled(true)
                self.info_node_lv_up_btn:setVisible(true)
                self:updateInfoNodeCostInfo(hero_info)
            end
        end

    end


    self.info_node_battle_info_power:setNum(hero_info.power)
    --self.info_node_battle_label:setString(hero_info.power)
    --self.info_node_battle_icon:setPositionX(self.info_node_battle_label:getPositionX() - self.info_node_battle_label:getContentSize().width - 22)
    self.info_node_lv_label2:setString(hero_info.lev)
    self.info_node_lv_label3:setString(string_format("/%s", self.limit_lev_max))
    self.info_node_lv_label3:setPositionX(self.info_node_lv_label2:getPositionX() + self.info_node_lv_label2:getContentSize().width)
    self.info_node_lv_bar:setPercent(100*hero_info.lev/self.limit_lev_max)

    loadSpriteTexture(self.info_node_profession_label_bg_career, PathTool.gw_getCareerWhiteIconCommon01(hero_info.type), LOADTEXT_TYPE_PLIST)
    self.info_node_profession_label_bg_desc_label:setString(hero_info.introduce_str)

    if self.num_change_flag ~= true then
        self.num_change_flag = false
        if self.last_hp ~= nil and self.last_def ~= nil and self.last_atk ~= nil and self.last_speed ~= nil then
            if self.last_hp ~= hero_info.hp or self.last_def ~= hero_info.def or self.last_atk ~= hero_info.atk or self.last_speed ~= hero_info.speed then
                self.hp_num_change_init = self.last_hp
                self.def_num_change_init = self.last_def
                self.atk_num_change_init = self.last_atk
                self.speed_num_change_init = self.last_speed
                self.num_change_flag = true
            end
        end

        self.last_hp = hero_info.hp
        self.last_def = hero_info.def
        self.last_atk = hero_info.atk
        self.last_speed = hero_info.speed

        if self.num_change_flag == true then
            if self.info_node_hp_attr_spine == nil then
                self.info_node_hp_attr_spine = gw_createEffectSpine("E90132", cc.p(0, 0), cc.p(0.5, 0.5), false, "xingjie_suaguang")
                self.info_node_hp_attr_spine_node:addChild(self.info_node_hp_attr_spine)
                local function animationCompleteFunc(event)
                    self.info_node_hp_attr_spine_node:setVisible(false)
                end
                self.info_node_hp_attr_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
            else
                self.info_node_hp_attr_spine:setAnimation(0, "xingjie_suaguang", false)
                self.info_node_hp_attr_spine_node:setVisible(true)
            end
            if self.info_node_def_attr_spine == nil then
                self.info_node_def_attr_spine = gw_createEffectSpine("E90132", cc.p(0, 0), cc.p(0.5, 0.5), false, "xingjie_suaguang")
                self.info_node_def_attr_spine_node:addChild(self.info_node_def_attr_spine)
                local function animationCompleteFunc(event)
                    self.info_node_def_attr_spine_node:setVisible(false)
                end
                self.info_node_def_attr_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
            else
                self.info_node_def_attr_spine:setAnimation(0, "xingjie_suaguang", false)
                self.info_node_def_attr_spine_node:setVisible(true)
            end
            if self.info_node_atk_attr_spine == nil then
                self.info_node_atk_attr_spine = gw_createEffectSpine("E90132", cc.p(0, 0), cc.p(0.5, 0.5), false, "xingjie_suaguang")
                self.info_node_atk_attr_spine_node:addChild(self.info_node_atk_attr_spine)
                local function animationCompleteFunc(event)
                    self.info_node_atk_attr_spine_node:setVisible(false)
                end
                self.info_node_atk_attr_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
            else
                self.info_node_atk_attr_spine:setAnimation(0, "xingjie_suaguang", false)
                self.info_node_atk_attr_spine_node:setVisible(true)
            end
            if self.info_node_speed_attr_spine == nil then
                self.info_node_speed_attr_spine = gw_createEffectSpine("E90132", cc.p(0, 0), cc.p(0.5, 0.5), false, "xingjie_suaguang")
                self.info_node_speed_attr_spine_node:addChild(self.info_node_speed_attr_spine)
                local function animationCompleteFunc(event)
                    self.info_node_speed_attr_spine_node:setVisible(false)
                end
                self.info_node_speed_attr_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
            else
                self.info_node_speed_attr_spine:setAnimation(0, "xingjie_suaguang", false)
                self.info_node_speed_attr_spine_node:setVisible(true)
            end

            self.info_node_hp_attr_spine_node:setVisible(true)
            self.info_node_def_attr_spine_node:setVisible(true)
            self.info_node_atk_attr_spine_node:setVisible(true)
            self.info_node_speed_attr_spine_node:setVisible(true)

            if self.info_node_attr_num_timer then
                GlobalTimeTicket:getInstance():remove(self.info_node_attr_num_timer)
                self.info_node_attr_num_timer = nil
            end

            local add_count = 0
            self.info_node_attr_num_timer = GlobalTimeTicket:getInstance():add(function()
                add_count = add_count + 1
                local hp_num = self.hp_num_change_init + math.ceil(add_count * (self.last_hp - self.hp_num_change_init) / 10)
                local def_num = self.def_num_change_init + math.ceil(add_count * (self.last_def - self.def_num_change_init) / 10)
                local atk_num = self.atk_num_change_init + math.ceil(add_count * (self.last_atk - self.atk_num_change_init) / 10)
                local speed_num = self.speed_num_change_init + math.ceil(add_count * (self.last_speed - self.speed_num_change_init) / 10)

                if add_count >= 10 then
                    if self.info_node_attr_num_timer then
                        GlobalTimeTicket:getInstance():remove(self.info_node_attr_num_timer)
                        self.info_node_attr_num_timer = nil
                    end
                    self.num_change_flag = false
                    self.info_node_hp_attr_value_label:setString(self.last_hp)
                    self.info_node_def_attr_value_label:setString(self.last_def)
                    self.info_node_atk_attr_value_label:setString(self.last_atk)
                    self.info_node_speed_attr_value_label:setString(self.last_speed)
                else
                    self.info_node_hp_attr_value_label:setString(hp_num)
                    self.info_node_def_attr_value_label:setString(def_num)
                    self.info_node_atk_attr_value_label:setString(atk_num)
                    self.info_node_speed_attr_value_label:setString(speed_num)
                end
            end, 0.05, 10)
        else
            self.info_node_hp_attr_spine_node:setVisible(false)
            self.info_node_def_attr_spine_node:setVisible(false)
            self.info_node_atk_attr_spine_node:setVisible(false)
            self.info_node_speed_attr_spine_node:setVisible(false)

            self.info_node_hp_attr_value_label:setString(hero_info.hp)
            self.info_node_def_attr_value_label:setString(hero_info.def)
            self.info_node_atk_attr_value_label:setString(hero_info.atk)
            self.info_node_speed_attr_value_label:setString(hero_info.speed)
        end
    else
        self.last_hp = hero_info.hp
        self.last_def = hero_info.def
        self.last_atk = hero_info.atk
        self.last_speed = hero_info.speed
    end



    --阶段
    if self.break_effect_flag == false then
        local max_count = model:getHeroMaxBreakCountByInitStar(hero_info.star)
        local break_count = break_lev or 0

        if self.last_break_count ~= nil and break_count <= 7 then
            if self.last_break_count < break_count then
                self.last_break_count = break_count
                break_count = break_count - 1
                self.break_effect_flag = true
            else
                self.last_break_count = break_count
            end
        else
            self.last_break_count = break_count
        end

        for i=1,7 do
            if i <= max_count then
                --local res = PathTool.getPlistImgForDownLoad("gw_hero_bag", "hero_info_stage_icon_empty", false)
                --if i <= break_count then
                --    res = PathTool.getPlistImgForDownLoad("gw_hero_bag", "hero_info_stage_icon_active", false)
                --end
                --loadSpriteTextureFromCDN(self.info_node_stage_list[i], res, ResourcesType.single)

                self.info_node_stage_list[i]:setVisible(i <= break_count)
                self.info_node_stage_bg_list[i]:setVisible(true)
            else
                self.info_node_stage_list[i]:setVisible(false)
                self.info_node_stage_bg_list[i]:setVisible(false)
            end
        end

        --需要播放进阶特效
        if self.break_effect_flag == true then
            local index = self.last_break_count
            local pos_x = self.info_node_stage_list[index]:getPositionX()-- + 23
            local pos_y = self.info_node_stage_list[index]:getPositionY()-- + 23

            if self.break_effect_spine == nil then
                self.break_effect_spine = gw_createEffectSpine("E90131", cc.p(pos_x, pos_y), cc.p(0.5, 0.5), false, "xingjiedonghua")
                self.info_node_stage_con:addChild(self.break_effect_spine)

                local function animationCompleteFunc(event)
                    Debug.log("animationCompleteFunc")
                    if self.break_effect_flag == true then
                        self.info_node_stage_list[self.last_break_count]:setVisible(true)
                        self.break_effect_spine:setVisible(false)
                        self.break_effect_flag = false
                    end
                end
                self.break_effect_spine:registerSpineEventHandler(animationCompleteFunc, sp.EventType.ANIMATION_COMPLETE)
            else
                self.break_effect_spine:setPosition(cc.p(pos_x, pos_y))
                self.break_effect_spine:setAnimation(0, "xingjiedonghua", false)
                self.break_effect_spine:setVisible(true)
            end

        end
    end

    --技能刷新
    local skill_list = {}
    if star_config == nil then
        Debug.error(string_format("英雄升星配置找不到！！!!bid:%s  star:%s", hero_info.bid, hero_info.star))
    else
        for i,v in ipairs(star_config.skills) do
            -- 不是普通攻击 1表示普通攻击
            if v[1] ~= 1 then
                table_insert(skill_list, v)
            end
        end
    end
    for i,v in ipairs(self.info_node_skill_list) do
        v:setVisible(false)
        self.info_node_skill_list[i].skill_bid = nil
    end
    if #skill_list > 0 then
        local x = 0
        for i,skill in ipairs(skill_list) do
            if i > #self.info_node_skill_list then
                break
            end
            local config = Config.SkillData.data_get_skill(skill[2])
            if config then
                --是否锁住
                local is_lock = false
                if skill[1] > break_config.skill_num  then
                    is_lock = true
                end

                self.info_node_skill_list[i].skill_bid = config.bid
                self.info_node_skill_list[i].is_lock = is_lock
                local skill_icon = PathTool.getSkillRes(config.icon, false)
                self.info_node_skill_list[i].icon:loadTexture(skill_icon, LOADTEXT_TYPE)
                --loadSpriteTexture(self.info_node_skill_list[i].icon, skill_icon, LOADTEXT_TYPE)
                local lev = 0
                if config.client_lev and config.client_lev > 0 then
                    lev = config.client_lev
                elseif config.level and config.level > 0 then
                    lev = config.level
                end
                self.info_node_skill_list[i].lev_label:setString(string_format("Lv.%s", lev))

                if is_lock == true then
                    self.info_node_skill_list[i].lev_bg:setVisible(false)
                    self.info_node_skill_list[i].lev_label:setVisible(false)
                    setChildUnEnabled(true, self.info_node_skill_list[i].icon_cover)
                    setChildUnEnabled(true, self.info_node_skill_list[i].icon)
                else
                    self.info_node_skill_list[i].lev_bg:setVisible(lev > 0)
                    self.info_node_skill_list[i].lev_label:setVisible(lev > 0)
                    setChildUnEnabled(false, self.info_node_skill_list[i].icon_cover)
                    setChildUnEnabled(false, self.info_node_skill_list[i].icon)
                end
                self.info_node_skill_list[i].lock_icon:setVisible(is_lock)

                self.info_node_skill_list[i]:setVisible(true)
            else
                Debug.error(string_format("技能表id: %s 没发现", tostring(skill.skill_bid)))
            end
        end
    end
end
function GW_HeroDetailWindow:updateInfoNodeCostInfo(hero_vo)
    if not hero_vo then return end
    if not self.limit_lev_max then return end

    local lev = hero_vo.lev or 1

    local max_lev_num = 1
    if lev < 60 then
        max_lev_num = 5
    end
    --能升多少级
    --能够升级最大等级
    local can_upgrade_max_lev = lev
    local dic_cost_list = {} --总消耗

    local function _checkEnough(up_cost)
        local cur_cost_list = {}
        local is_enough = true
        for i,cost in ipairs(up_cost) do
            if dic_cost_list[cost[1]] == nil then
                dic_cost_list[cost[1]] = 0
            end
            cur_cost_list[cost[1]] = dic_cost_list[cost[1]] + cost[2]
            local count = BackpackController:getInstance():getModel():getItemNumByBid(cost[1]) or 0
            if count < cur_cost_list[cost[1]] then
                --不够了
                is_enough = false
            end
        end

        return is_enough, cur_cost_list
    end


    --升级消耗
    for i=1,max_lev_num do
        local lev1 = lev + i - 1
        if lev1 >= self.limit_lev_max then
            break
        end
        local lev_config = Config.PartnerData.data_partner_lev[lev1]
        if lev_config then

            local up_cost = lev_config.expend or {}
            local is_enough, cost_list = _checkEnough(up_cost)

            if is_enough then
                dic_cost_list = cost_list
                can_upgrade_max_lev = lev1
            else
                if i == 1 then
                    dic_cost_list = cost_list
                end
                break
            end
        end
    end

    for i,lv_consume in ipairs(self.info_node_lv_consume) do
        lv_consume.item_id = nil
        lv_consume.item_num = nil
        lv_consume.icon:setVisible(false)
        lv_consume.num:setVisible(false)
        if lv_consume.line then
            lv_consume.line:setVisible(false)
        end
    end
    self:setInfoNodeLevName(hero_vo, can_upgrade_max_lev - lev + 1)
    local lev_config = Config.PartnerData.data_partner_lev[lev]
    if lev_config then
        local posX = -510
        local up_cost = lev_config.expend or {}
        for i,cost in ipairs(up_cost) do
            if i > #self.info_node_lv_consume then
                break
            end
            local config = Config.ItemData.data_get_data(cost[1])
            if config and self.info_node_lv_consume[i] then
                self.info_node_lv_consume[i].item_id = cost[1]
                self.info_node_lv_consume[i].item_num = dic_cost_list[cost[1]]

                local head_icon = PathTool.getItemRes(config.icon, false)
                loadSpriteTexture(self.info_node_lv_consume[i].icon, head_icon, LOADTEXT_TYPE)
                self.info_node_lv_consume[i].num:setString(dic_cost_list[cost[1]])
                local count = BackpackController:getInstance():getModel():getItemNumByBid(cost[1])
                if dic_cost_list[cost[1]] and count < dic_cost_list[cost[1]] then
                    self.info_node_lv_consume[i].num:setTextColor(cc.c4b(0xf4,0x3e,0x3e,0xff))
                else
                    self.info_node_lv_consume[i].num:setTextColor(cc.c4b(0x3a,0x3d,0x40,0xff))
                end

                self.info_node_lv_consume[i].icon:setVisible(true)
                self.info_node_lv_consume[i].num:setVisible(true)
                --self.info_node_lv_consume[i].icon:setPositionX(posX)
                --self.info_node_lv_consume[i].num:setPositionX(posX+30)

                if self.info_node_lv_consume[i].line then
                    self.info_node_lv_consume[i].line:setVisible(i < #up_cost)
                    --self.info_node_lv_consume[i].line:setPositionX(posX+30+self.info_node_lv_consume[i].num:getContentSize().width + 40)
                    --
                    --posX = self.info_node_lv_consume[i].line:getPositionX() + 40
                end

            end
        end
    end
end
function GW_HeroDetailWindow:setInfoNodeLevName(hero_vo, lev)
    if not hero_vo then return end
    --if lev > 1 then
    --else
    --end
    self.info_node_lv_up_btn_label2:setString(lev)
    self.info_node_lv_up_btn_label2:setPositionX(self.info_node_lv_up_btn_label1:getPositionX() + self.info_node_lv_up_btn_label1:getContentSize().width)
    self.info_node_lv_up_btn_label1:setVisible(true);
end

--刷新上方货币
function GW_HeroDetailWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    if self.top_num_wealth_list[3] ~= nil then
        local key = "hero_exp"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[3].btn:setVisible(true)
    end
end

--更新点金红点
function GW_HeroDetailWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and role_vo and red_lev_min and red_lev_min.val <= role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end
--刷新装备页面
function GW_HeroDetailWindow:updateEquipNode(hero_vo)
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.Equip then
        return
    end

    --装备信息
    local equip_list = model:getHeroEquipList(hero_vo.partner_id)
    for i,_type in ipairs(self.equip_type_list) do
        local equip_vo = equip_list[_type]
        local item = self.equip_node_list[_type]
        if equip_vo then
            local id = equip_vo.id or equip_vo.bid
            local item_config = nil
            if equip_vo.config == nil then
                item_config = Config.ItemData.data_get_data(id)
            else
                item_config = equip_vo.config
            end
            --local head_icon = PathTool.getItemRes(item_config.icon, false)
            --loadSpriteTexture(item.icon, head_icon, LOADTEXT_TYPE)
            --loadSpriteTexture(item.stage, PathTool.gw_getStarCommon01(item_config.eqm_star), LOADTEXT_TYPE_PLIST)
            item.item:setBaseData(item_config.id, 0)
            item.item:showNumLabel(false)

            item.unlock_bg:setVisible(true)
            item.lock_bg:setVisible(false)
            item.empty_icon:setVisible(false)
            item.item_node:setVisible(true)
            --item.icon:setVisible(true)
            --item.stage:setVisible(true)
            item.lock:setVisible(false)
            item.equip_vo = equip_vo
        else
            item.unlock_bg:setVisible(true)
            item.lock_bg:setVisible(false)
            item.empty_icon:setVisible(true)
            item.item_node:setVisible(false)
            --item.icon:setVisible(false)
            --item.stage:setVisible(false)
            item.lock:setVisible(false)
            item.equip_vo = nil
        end
    end

    --符文信息
    --解锁信息
    self.lock_list = {}
    for i,v in ipairs(self.artifact_lock_list) do
        local is_lock = true
        --local item = self.equip_node_list[i+4]
        if v[1] == 'lev' then
            if hero_vo.lev >= v[2]  then
                --已解锁
                is_lock = false
                --item.icon:setVisible(true)
                --item.lock:setVisible(false)
                --item.label:setVisible(false)
                --item.btn:setVisible(true)
            --else
            --    local max_lev = Config.PartnerData.data_partner_max_lev[hero_vo.bid]
            --    if max_lev and max_lev >= v[2] then
            --        item.label:setString(v[2]..TI18N("级解锁"))
            --        item.icon:setVisible(false)
            --        item.lock:setVisible(true)
            --        item.label:setVisible(true)
            --        item.btn:setVisible(true)
            --    else
            --        item.icon:setVisible(false)
            --        item.lock:setVisible(false)
            --        item.label:setVisible(false)
            --        item.btn:setVisible(false)
            --    end
            end
        elseif v[1] == 'star' then
            --local max_star = Config.PartnerData.data_partner_max_star[hero_vo.bid]
            --if max_star and max_star < v[2] then
            --    --策划要求不满星级的要隐藏
            --    item.icon:setVisible(false)
            --    item.lock:setVisible(false)
            --    item.label:setVisible(false)
            --    item.btn:setVisible(false)
            --else
                if hero_vo.star >= v[2] then
                    is_lock = false
                --    item.icon:setVisible(true)
                --    item.lock:setVisible(false)
                --    item.label:setVisible(false)
                --else
                --    item.label:setString(v[2]..TI18N("星解锁"))
                --    item.icon:setVisible(false)
                --    item.lock:setVisible(true)
                --    item.label:setVisible(true)
                end

            --    item.btn:setVisible(true)
            --end
        end
        self.lock_list[i] = is_lock
    end
    --self.equip_node_list[5] [6] 是符文信息
    if hero_vo.artifact_list then
        for i=1,2 do
            local item = self.equip_node_list[i+4]

            if self.lock_list[i] == true then
                item.unlock_bg:setVisible(false)
                item.lock_bg:setVisible(true)
                item.empty_icon:setVisible(true)
                item.item_node:setVisible(false)
                --item.icon:setVisible(false)
                --item.stage:setVisible(false)
                item.lock:setVisible(true)
                item.equip_vo = nil
            else
                local equip_vo = hero_vo.artifact_list[i]
                if equip_vo then
                    local id = equip_vo.id or equip_vo.bid
                    local item_config = nil
                    if equip_vo.config == nil then
                        item_config = Config.ItemData.data_get_data(id)
                    else
                        item_config = equip_vo.config
                    end
                    --local head_icon = PathTool.getItemRes(item_config.icon, false)
                    --loadSpriteTexture(item.icon, head_icon, LOADTEXT_TYPE)
                    item.item:setBaseData(item_config.id, 0)
                    item.item:showNumLabel(false)

                    item.unlock_bg:setVisible(true)
                    item.lock_bg:setVisible(false)
                    item.empty_icon:setVisible(false)
                    item.item_node:setVisible(true)
                    --item.icon:setVisible(true)
                    --item.stage:setVisible(false)
                    item.lock:setVisible(false)
                    item.equip_vo = equip_vo
                else
                    item.unlock_bg:setVisible(true)
                    item.lock_bg:setVisible(false)
                    item.empty_icon:setVisible(true)
                    item.item_node:setVisible(false)
                    --item.icon:setVisible(false)
                    --item.stage:setVisible(false)
                    item.lock:setVisible(false)
                    item.equip_vo = nil
                end
            end
        end
    end

    --神器信息
    local item = self.equip_node_list[7]
    item.unlock_bg:setVisible(false)
    item.lock_bg:setVisible(true)
    item.empty_icon:setVisible(true)
    item.item_node:setVisible(false)
    --item.icon:setVisible(false)
    --item.stage:setVisible(false)
    item.lock:setVisible(true)
    item.equip_vo = nil

    self:updateEquipNodeRedPoint()
    self:updateEquipNodeOneKeyBtnStatus()
end
--更新一键穿戴/卸下按钮显示
function GW_HeroDetailWindow:updateEquipNodeOneKeyBtnStatus()
    --if not self.index or not self.show_list then return end
    --local hero_vo = self.show_list[self.index]
    --if hero_vo and hero_vo.eqm_list then
    --    -- 装备有红点时，或者没穿戴任何装备时，显示一键穿戴，否则显示一键卸下
    --    if self.equip_node_is_btn_redpoint or tableLen(hero_vo.eqm_list) <= 0 then
    --        self.equip_node_key_up_btn:setVisible(true)
    --        self.equip_node_discharge_btn:setVisible(false)
    --    else
    --        self.equip_node_key_up_btn:setVisible(false)
    --        self.equip_node_discharge_btn:setVisible(true)
    --    end
    --else
    --    self.equip_node_key_up_btn:setVisible(false)
    --    self.equip_node_discharge_btn:setVisible(false)
    --end
end
function GW_HeroDetailWindow:updateEquipNodeRedPoint()
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]
    --按钮的红点
    local is_btn_redpoint = false
    --装备红点
    for i=1,4 do
        local equip_type = HeroConst.EquipPosList[i]
        local is_redpoint = self:updateEquipNodeEachEquipRedPoint(equip_type, hero_vo)
        if not is_btn_redpoint and is_redpoint == true then
            is_btn_redpoint = is_redpoint
            --break
        end
    end

    self.equip_node_key_up_btn_redpoint:setVisible(is_btn_redpoint)
    if is_btn_redpoint == true then
        if self.equip_node_key_up_btn_redpoint_spine == nil then
            self.equip_node_key_up_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
            self.equip_node_key_up_btn_redpoint:addChild(self.equip_node_key_up_btn_redpoint_spine)
        end
    end
    self.equip_node_is_btn_redpoint = is_btn_redpoint

    --符文(神器) 红点
    if self.lock_list then
        for i,v in ipairs(self.artifact_lock_list) do
            local item = self.equip_node_list[i+4]
            if not self.lock_list[i] then
                --Debug.log("123-------------")
                local equip_vo = hero_vo.artifact_list[i]
                local is_redpoint = HeroCalculate.checkSingleArtifactRedPoint(equip_vo)
                item.redpoint:setVisible(is_redpoint)
                if is_redpoint == true then
                    if item.redpoint_spine == nil then
                        item.redpoint_spine = PathTool.gw_createRedpointSpine()
                        item.redpoint:addChild(item.redpoint_spine)
                    end
                end
            else
                --Debug.log("456-------------")
                item.redpoint:setVisible(false)
            end
        end
    end

    local item = self.equip_node_list[7]
    item.redpoint:setVisible(false)
end
--更新每一个装备红点
function GW_HeroDetailWindow:updateEquipNodeEachEquipRedPoint(equip_type, hero_vo)
    local equip_list = model:getHeroEquipList(hero_vo.partner_id)
    local item = self.equip_node_list[equip_type]
    local is_redpoint = HeroCalculate.checkSingleHeroEachPosEquipRedPoint(equip_type, equip_list[equip_type])
    item.redpoint:setVisible(is_redpoint)
    if is_redpoint == true then
        if item.redpoint_spine == nil then
            item.redpoint_spine = PathTool.gw_createRedpointSpine()
            item.redpoint:addChild(item.redpoint_spine)
        end
    end
    return is_redpoint
end

--刷新升星页面
function GW_HeroDetailWindow:updateUpgradeStarNode(hero_vo)
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.UpgradeStar then
        return
    end

    local star = hero_vo.star or 1
    loadSpriteTexture(self.upgrade_star_node_star, PathTool.gw_getStarCommon01(star), LOADTEXT_TYPE_PLIST)
    if star < 6 then
        self.upgrade_star_node_star:setPositionX(-221)
        self.upgrade_star_node_star:setPositionY(225)
        self.upgrade_star_node_star:setScale(1)
    elseif star < 10 then
        self.upgrade_star_node_star:setPositionX(-221)
        self.upgrade_star_node_star:setPositionY(225)
        self.upgrade_star_node_star:setScale(1)
    else
        self.upgrade_star_node_star:setPositionX(-221)
        self.upgrade_star_node_star:setPositionY(225)
        self.upgrade_star_node_star:setScale(0.5)
    end

    local key = getNorKey(hero_vo.bid, star)
    local star_config = Config.PartnerData.data_partner_star(key)
    local next_key = getNorKey(hero_vo.bid, star + 1)
    local next_star_config = Config.PartnerData.data_partner_star(next_key)

    --更新属性
    self:updateUpgradeStarNodeAttrUI(hero_vo, star_config, next_star_config)

    if next_star_config == nil then
        --self.upgrade_star_node_upgrade_star_btn:setVisible(false)
        self.is_max_star = true
        for i=1,4 do
            self.upgrade_star_node_item_list[i]:setVisible(false)
        end
        self.upgrade_star_node_consume_coin_bg:setVisible(false)
        self.upgrade_star_node_upgrade_star_btn:setVisible(false)
    else
        --self.upgrade_star_node_upgrade_star_btn:setVisible(true)
        self.is_max_star = false
        --升星材料
        self:updateUpgradeStarNodeItemDataByConfig(next_star_config)
        self.upgrade_star_node_upgrade_star_btn:setVisible(true)
    end
end
--更新属性ui
function GW_HeroDetailWindow:updateUpgradeStarNodeAttrUI(hero_vo, star_config, next_star_config)
    --刷新等级上限
    self.upgrade_star_node_lev_max.cur_max:setString(string_format("Lv.%s", star_config.lev_max))
    self.upgrade_star_node_lev_max.next_max:setString(string_format("Lv.%s", star_config.lev_max))
    if next_star_config ~= nil then
        self.upgrade_star_node_lev_max.next_max:setString(string_format("Lv.%s", next_star_config.lev_max))
    end

    --刷新所有技能等级
    local old_skill = nil
    local new_skill_list = {}
    --[序号] = 技能id
    local dic_old_skill = {}
    for i,v in ipairs(star_config.skills) do
        dic_old_skill[v[1]] = v[2]
    end
    if next_star_config ~= nil then
        for i,v in ipairs(next_star_config.skills) do
            -- == 1 表示普通技能
            if v[1] ~= 1 then
                if dic_old_skill[v[1]] then
                    if dic_old_skill[v[1]] ~= v[2] then
                        if old_skill == nil then
                            old_skill = dic_old_skill[v[1]]
                        end
                        table_insert(new_skill_list, v[2])
                    end
                else --说明升星产生新技能了
                    if old_skill == nil then
                        old_skill = dic_old_skill[v[1]]
                    end
                    table_insert(new_skill_list, v[2])
                end
            end
        end

        local skill_count = #new_skill_list
        if skill_count > 0 then
            if skill_count == 1 and old_skill ~= nil then
                local skill_lev = 1
                local skill_config = Config.SkillData.data_get_skill(old_skill)
                if skill_config.client_lev and skill_config.client_lev > 0 then
                    skill_lev = skill_config.client_lev
                elseif skill_config.level and skill_config.level > 0 then
                    skill_lev = skill_config.level
                end
                self.upgrade_star_node_skill_lev.cur_max:setString(string.format("Lv.%d", skill_lev))

                local skill_lev = 1
                local skill_config = Config.SkillData.data_get_skill(new_skill_list[1])
                if skill_config.client_lev and skill_config.client_lev > 0 then
                    skill_lev = skill_config.client_lev
                elseif skill_config.level and skill_config.level > 0 then
                    skill_lev = skill_config.level
                end
                self.upgrade_star_node_skill_lev.next_max:setString(string.format("Lv.%d", skill_lev))

                self.upgrade_star_node_skill_lev.title:setString(string.format("%s:", skill_config.name))
            else
                local skill_lev = 1
                if old_skill ~= nil then
                    local skill_config = Config.SkillData.data_get_skill(old_skill)
                    if skill_config.client_lev and skill_config.client_lev > 0 then
                        skill_lev = skill_config.client_lev
                    elseif skill_config.level and skill_config.level > 0 then
                        skill_lev = skill_config.level
                    end
                end
                self.upgrade_star_node_skill_lev.cur_max:setString(string.format("Lv.%d", skill_lev))

                local skill_lev = 1
                local skill_config = Config.SkillData.data_get_skill(new_skill_list[1])
                if skill_config.client_lev and skill_config.client_lev > 0 then
                    skill_lev = skill_config.client_lev
                elseif skill_config.level and skill_config.level > 0 then
                    skill_lev = skill_config.level
                end
                self.upgrade_star_node_skill_lev.next_max:setString(string.format("Lv.%d", skill_lev))

                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(1134))

            end

            self.upgrade_star_node_skill_lev:setVisible(true)
            if star_config.star == 5 then
                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(10000047))
            elseif star_config.star == 6 then
                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(10000048))
            elseif star_config.star == 7 then
                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(10000049))
            elseif star_config.star == 8 then
                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(10000050))
            elseif star_config.star == 9 then
                self.upgrade_star_node_skill_lev.title:setString(UI_TI18N(10000051))
            else
                self.upgrade_star_node_skill_lev:setVisible(false)
            end

        else
            --到这里表示此英雄没有技能提升
            self.upgrade_star_node_skill_lev:setVisible(false)
        end

    else
        self.upgrade_star_node_skill_lev:setVisible(false)
    end

    self.upgrade_star_node_hp_attr.cur_value:setString(hero_vo.hp)
    self.upgrade_star_node_hp_attr.next_value:setString(hero_vo.next_star_hp_max or hero_vo.hp)
    local up_value = 0
    if hero_vo.next_star_hp_max and hero_vo.next_star_hp_max > hero_vo.hp then
        up_value = hero_vo.next_star_hp_max - hero_vo.hp
    end
    self.upgrade_star_node_hp_attr.rise_value:setString(string_format("+%s", up_value))

    self.upgrade_star_node_def_attr.cur_value:setString(hero_vo.def)
    self.upgrade_star_node_def_attr.next_value:setString(hero_vo.next_star_def or hero_vo.def)
    local up_value = 0
    if hero_vo.next_star_def and hero_vo.next_star_def > hero_vo.def then
        up_value = hero_vo.next_star_def - hero_vo.def
    end
    self.upgrade_star_node_def_attr.rise_value:setString(string_format("+%s", up_value))

    self.upgrade_star_node_atk_attr.cur_value:setString(hero_vo.atk)
    self.upgrade_star_node_atk_attr.next_value:setString(hero_vo.next_star_atk or hero_vo.atk)
    local up_value = 0
    if hero_vo.next_star_atk and hero_vo.next_star_atk > hero_vo.atk then
        up_value = hero_vo.next_star_atk - hero_vo.atk
    end
    self.upgrade_star_node_atk_attr.rise_value:setString(string_format("+%s", up_value))

    self.upgrade_star_node_speed_attr.cur_value:setString(hero_vo.speed)
    self.upgrade_star_node_speed_attr.next_value:setString(hero_vo.next_star_speed or hero_vo.speed)
    local up_value = 0
    if hero_vo.next_star_speed and hero_vo.next_star_speed > hero_vo.speed then
        up_value = hero_vo.next_star_speed - hero_vo.speed
    end
    self.upgrade_star_node_speed_attr.rise_value:setString(string_format("+%s", up_value))
end
--更新升星物品材料
function GW_HeroDetailWindow:updateUpgradeStarNodeItemDataByConfig(star_config)
    if not self.index or not self.show_list then return end
    self.hero_vo = self.show_list[self.index]

    if not star_config then return end
    self.hero_item_data_list = {}
    --红点条件list
    local conditions_list = {}
    --记录已选id [partner_id] = hero_vo
    self.dic_other_selected = {}
    --过滤自己
    if self.hero_vo then
        self.dic_other_selected[self.hero_vo.partner_id] = self.hero_vo
    end
    -- local expend = star_config.expend1[1]
    -- if expend then --主卡
    --     --指定的 {10402,4,1} : 10402: 表示bid, 4: 表示星级 1:表示数量
    --     self.hero_item_data_list[index] = self:getHeroData(expend[1], expend[2], expend[3])
    -- end

    --指定的 {10402,4,1} : 10402: 表示bid, 4: 表示星级 1:表示数量
    local index = 1
    for i,expend in ipairs(star_config.expend2) do
        local base_config = Config.PartnerData.data_partner_base[expend[1]]
        if base_config ~= nil then
            self.hero_item_data_list[index] = self:getHeroData(expend[1], expend[2], expend[3])
            conditions_list[index] = {}
            conditions_list[index][expend[1]] = {}
            conditions_list[index][expend[1]][expend[2]] = expend[3]
            index = index + 1
        else
            Debug.error(string_format("英雄%s %s星升星材料配置错误,找不到材料英雄id%s", star_config.bid, star_config.star, expend[1]))
        end
    end
    --随机的 {1,4,2} : 1 表示阵营  4: 表示星级 2表示数量
    for i,expend in ipairs(star_config.expend3) do
        self.hero_item_data_list[index] = self:getHeroData(nil, expend[2], expend[3], expend[1])
        conditions_list[index] = {}
        conditions_list[index][expend[1]] = {}
        conditions_list[index][expend[1]][expend[2]] = expend[3]
        index = index + 1
    end

    for i,item in ipairs(self.upgrade_star_node_item_list) do
        item:setVisible(false)
    end

    for i,hero_vo in ipairs(self.hero_item_data_list) do
        local gw_item = self.upgrade_star_node_item_list[i]
        if gw_item == nil then break end
        --if i > #self.upgrade_star_node_item_list then
        --    break
        --end

        if hero_vo.bid == 0 then
            loadSpriteTexture(gw_item.icon, PathTool.getItemRes(model:getRandomHeroHeadByQuality(hero_vo.star or 1)), LOADTEXT_TYPE)
            --self.upgrade_star_node_item_list[i].name:setString(string_format(UI_TI18N(1136), hero_vo.star))
        else
            --local key = getNorKey(hero_vo.bid, hero_vo.star)
            --local star_config = Config.PartnerData.data_partner_star(key)
            loadSpriteTexture(gw_item.icon, PathTool.gw_getHeadIcon(star_config.head_id), LOADTEXT_TYPE)
            --self.upgrade_star_node_item_list[i].name:setString(string_format("%s", hero_vo.name))
        end
        local quality = (hero_vo.star or 1)-1
        local res_id = PathTool.gw_getItemQualityCommon01(quality)
        gw_item.quality:loadTexture(res_id, LOADTEXT_TYPE_PLIST)
        loadSpriteTexture(gw_item.camp_type, PathTool.gw_getCampTypeCommon01(hero_vo.camp_type), LOADTEXT_TYPE_PLIST)
        local star = hero_vo.star or 1
        if star <= 5 then
            loadSpriteTexture(gw_item.star, PathTool.gw_getStarCommon01(star), LOADTEXT_TYPE_PLIST)
            gw_item.star:setVisible(true)
            gw_item.star_spine_node:setVisible(false)
        elseif star < 10 then
            loadSpriteTexture(gw_item.star, PathTool.gw_getStarCommon01(star), LOADTEXT_TYPE_PLIST)
            gw_item.star:setVisible(true)
            gw_item.star_spine_node:setVisible(false)
        else
            if gw_item.star_spine == nil then
                gw_item.star_spine = gw_createEffectSpine("E90121", cc.p(0, 0), cc.p(0.5, 0.5), true, "kapian_xingsaoguang")
                gw_item.star_spine_node:addChild(self.star_spine)
            end
            gw_item.star:setVisible(false)
            gw_item.star_spine_node:setVisible(true)
        end


        local count = 0
        for k,vo in pairs(hero_vo.dic_select_list) do
            count = count + 1
        end
        gw_item.num1:setString(count)
        gw_item.num2:setString(string_format("/%s", hero_vo.count))
        gw_item.num2:setPositionX(gw_item.num1:getPositionX() + gw_item.num1:getContentSize().width)
        if count < hero_vo.count then
            gw_item.num1:setTextColor(cc.c4b(0xf4,0x3e,0x3e,0xff))
        else
            gw_item.num1:setTextColor(cc.c4b(0xff,0xff,0xff,0xff))
        end
        setChildUnEnabled(true, gw_item.icon)
        gw_item:setVisible(true)
    end

    -- 额外材料
    self.upgrade_star_node_consume_coin_bg:setVisible(false)
    if star_config.other_expend and star_config.other_expend[1] then
        local item_type = star_config.other_expend[1][1]
        local item_num = star_config.other_expend[1][2]
        local have_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(item_type)
        self.upgrade_star_node_consume_coin_bg_label1:setString(string_format("%s", have_num))
        if have_num >= item_num then
            self.upgrade_star_node_consume_coin_bg_label1:setTextColor(cc.c4b(0xff,0xff,0xff,0xff))
        else
            self.upgrade_star_node_consume_coin_bg_label1:setTextColor(cc.c4b(0xff,0x00,0x00,0xff))
        end
        self.upgrade_star_node_consume_coin_bg_label2:setString(string_format("/%s", item_num))
        self.upgrade_star_node_consume_coin_bg_label1:setPositionX(self.upgrade_star_node_consume_coin_bg_label2:getPositionX() - self.upgrade_star_node_consume_coin_bg_label2:getContentSize().width)
        local config = Config.ItemData.data_get_data(item_type)
        loadSpriteTexture(self.upgrade_star_node_consume_coin_bg_icon, PathTool.getItemRes(config.icon, false), LOADTEXT_TYPE)
        self.upgrade_star_node_consume_coin_bg:setVisible(true)
    else
        self.upgrade_star_node_consume_coin_bg:setVisible(false)
    end

    self:initUpgradeStarNodeHeroListByMatchInfo(conditions_list)
    self:updateUpgradeStarNodeItemRedPoint()
end
--初始化英雄列表匹配信息
function GW_HeroDetailWindow:initUpgradeStarNodeHeroListByMatchInfo(conditions_list)
    local hero_list = model:getHeroList()

    self.conditions_hero_list = {}
    for k,hero in pairs(hero_list) do
        for i,conditions in ipairs(conditions_list) do
            if self.conditions_hero_list[i] == nil then
                self.conditions_hero_list[i] = {}
            end

            if self.hero_item_data_list[i].bid == 0 then
                --表示随机卡 0表示全部阵营
                if conditions[0] then
                    if conditions[0][hero.star] then
                        table_insert(self.conditions_hero_list[i], hero)
                    end
                else
                    if conditions[hero.camp_type] and conditions[hero.camp_type][hero.star] ~= nil then
                        table_insert(self.conditions_hero_list[i], hero)
                    end
                end
            else
                --指定卡
                if conditions[hero.bid] and conditions[hero.bid][hero.star] then   -- 指定卡要剔除自己
                    if self.hero_vo and self.hero_vo.partner_id ~= hero.partner_id then
                        table_insert(self.conditions_hero_list[i], hero)
                    end
                end
            end
        end
    end

    --新加需求.自动填满指定定的位置的英雄
    -- if self.hero_vo and self.hero_vo.red_point[HeroConst.RedPointType.eRPStar] then
    self.dic_other_selected = {}
    if self.hero_vo then
        self.dic_other_selected[self.hero_vo.partner_id] = self.hero_vo
    end
    for i,v in ipairs(self.hero_item_data_list) do
        --策划要求指定才需要填充
        if v.bid ~= 0 then
            if self.conditions_hero_list[i] and #self.conditions_hero_list[i] > 0 then
                local sort_func = SortTools.tableCommonSorter({{"lev", false}, {"id", true}})
                table_sort(self.conditions_hero_list[i], sort_func)
                local count = 0
                for _,hero_vo in ipairs(self.conditions_hero_list[i]) do
                    if self.dic_other_selected[hero_vo.id] == nil and not hero_vo:checkHeroLockTips(true, nil, true) then
                        v.dic_select_list[hero_vo.id] = hero_vo
                        count = count + 1
                        if count >= v.count then
                            break
                        end
                    end
                end
                if count < v.count then
                    --说明不够..就不显示了
                    v.dic_select_list = {}
                else
                    for k,v in pairs(v.dic_select_list) do
                        self.dic_other_selected[k] = v
                    end
                    v.lev = string_format("%s/%s", count, v.count)
                    if self.upgrade_star_node_item_list[i] then
                        self.upgrade_star_node_item_list[i].num1:setString(count)
                        self.upgrade_star_node_item_list[i].num2:setString(string_format("/%s", v.count))
                        self.upgrade_star_node_item_list[i].num2:setPositionX(self.upgrade_star_node_item_list[i].num1:getPositionX() + self.upgrade_star_node_item_list[i].num1:getContentSize().width)
                        if count < v.count then
                            self.upgrade_star_node_item_list[i].num1:setTextColor(cc.c4b(0xf4,0x3e,0x3e,0xff))
                        else
                            self.upgrade_star_node_item_list[i].num1:setTextColor(cc.c4b(0xff,0xff,0xff,0xff))
                        end
                        if count > 0 then
                            setChildUnEnabled(false, self.upgrade_star_node_item_list[i].icon)
                        else
                            setChildUnEnabled(true, self.upgrade_star_node_item_list[i].icon)
                        end
                    end
                end
            end
        end
    end
    -- end


    local list = BackpackController:getInstance():getModel():getHeroHunList()
    for k, good_vo in pairs(list) do
        if good_vo.config then
            for i,conditions in ipairs(conditions_list) do
                if self.conditions_hero_list[i] == nil then
                    self.conditions_hero_list[i] = {}
                end
                if self.hero_item_data_list[i].bid == 0 then
                    --表示随机卡 0表示全部阵营
                    local camp_type = good_vo.config.camp_type
                    local star = good_vo.config.eqm_jie
                    if conditions[camp_type] and conditions[camp_type][star] ~= nil then
                        for j=1,good_vo.quantity do
                            local data = {}
                            data.id = -(j + camp_type * 10)
                            data.partner_id = data.id
                            data.good_vo = good_vo
                            table_insert(self.conditions_hero_list[i], data)
                        end
                    end
                end
            end
        end
    end
end
--计算中间item红点显示
function GW_HeroDetailWindow:updateUpgradeStarNodeItemRedPoint()
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]

    if not self.conditions_hero_list then return end
    if not self.dic_other_selected then return end

    local full_flag = true
    for i,item in ipairs(self.upgrade_star_node_item_list) do
        --模拟的hero_vo数据
        local hero_vo = self.hero_item_data_list[i]
        local conditions_list =  self.conditions_hero_list[i] or {}
        if hero_vo then
            local count = 0
            for k,v in pairs(hero_vo.dic_select_list) do
                count = count + 1
            end
            --已经填满了就不显示红点了
            if count < hero_vo.count then
                full_flag = false
                --随机卡的 --指定卡 逻辑一样的
                local num = hero_vo.count
                for i,each_hero in ipairs(conditions_list) do
                    --自已选的.和 别人没选的 都算数
                    if hero_vo.dic_select_list[each_hero.id] or self.dic_other_selected[each_hero.id] == nil then

                        if each_hero:checkHeroLockTips(true, nil, true) == false then
                            num = num - 1
                        end
                        --num = num - 1
                        if num == 0 then
                            break
                        end
                    end
                end
                --说明数量够 显示红点
                local status = (num <= 0)
                item.redpoint:setVisible(status)
                if status == true then
                    if item.redpoint_spine == nil then
                        item.redpoint_spine = PathTool.gw_createRedpointSpine()
                        item.redpoint:addChild(item.redpoint_spine)
                    end
                end

            else
                item.redpoint:setVisible(false)
            end
        end
    end

    if full_flag == true then
        local star = hero_vo.star or 1
        local next_key = getNorKey(hero_vo.bid, star + 1)
        local next_star_config = Config.PartnerData.data_partner_star(next_key)
        if next_star_config then
            if next_star_config.other_expend and next_star_config.other_expend[1] then
                local item_type = next_star_config.other_expend[1][1]
                local item_num = next_star_config.other_expend[1][2]
                local have_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(item_type)
                if have_num < item_num then
                    full_flag = false
                end
            end
        else
            full_flag = false
        end
    end

    self.upgrade_star_node_upgrade_star_btn_redpoint:setVisible(full_flag)
    if full_flag == true then
        if self.upgrade_star_node_upgrade_star_btn_redpoint_spine == nil then
            self.upgrade_star_node_upgrade_star_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
            self.upgrade_star_node_upgrade_star_btn_redpoint:addChild(self.upgrade_star_node_upgrade_star_btn_redpoint_spine)
        end
    end
end
--点击材料数据
function GW_HeroDetailWindow:onClickUpgradeStarNodeItemBtn(index)
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]

    if not self.hero_item_data_list[index] then return end
    if not hero_vo then return end
    --标志点击了那个
    self.hero_item_data_list[index].is_select = true
    --被其他人选择的列表 [id] = hero_vo 模式
    local dic_other_selected = {}
    --把自己也过滤
    dic_other_selected[hero_vo.partner_id] = hero_vo
    for i,item in ipairs(self.hero_item_data_list) do
        if i ~= index then
            for k,v in pairs(item.dic_select_list) do
                dic_other_selected[k] = v
            end
        end
    end

    local setting = {}
    if self.hero_item_data_list[index].bid == 0 and self.hero_item_data_list[index].star == 5 then
        -- 表示随机卡
        setting.self_mark_bid = hero_vo.bid
    end

    controller:openHeroUpgradeStarSelectPanel(true, self.hero_item_data_list[index], dic_other_selected, HeroConst.SelectHeroType.eUpgradeStar, setting)
end
--更新选中英雄信息
function GW_HeroDetailWindow:updateHeroItemInfo()
    if not self.hero_item_data_list or not self.upgrade_star_node_item_list then return end
    self.dic_other_selected = {}
    --过滤自己
    if self.hero_vo then
        self.dic_other_selected[self.hero_vo.partner_id] = self.hero_vo
    end
    for i,v in ipairs(self.hero_item_data_list) do
        if v.is_select then
            v.is_select = false
            local count = 0
            for k,vo in pairs(v.dic_select_list) do
                count = count + 1
                self.dic_other_selected[k] = vo
            end

            v.lev = string_format("%s/%s", count, v.count)
            if self.upgrade_star_node_item_list[i].num1 then
                self.upgrade_star_node_item_list[i].num1:setString(count)
                self.upgrade_star_node_item_list[i].num2:setString(string_format("/%s", v.count))
                self.upgrade_star_node_item_list[i].num2:setPositionX(self.upgrade_star_node_item_list[i].num1:getPositionX() + self.upgrade_star_node_item_list[i].num1:getContentSize().width)
                if count < v.count then
                    self.upgrade_star_node_item_list[i].num1:setTextColor(cc.c4b(0xf4,0x3e,0x3e,0xff))
                else
                    self.upgrade_star_node_item_list[i].num1:setTextColor(cc.c4b(0xff,0xff,0xff,0xff))
                end
                if count > 0 then
                    setChildUnEnabled(false, self.upgrade_star_node_item_list[i].icon)
                else
                    setChildUnEnabled(true, self.upgrade_star_node_item_list[i].icon)
                end
            end
        else
            for k,vo in pairs(v.dic_select_list) do
                self.dic_other_selected[k] = vo
            end
        end
    end
    self:updateUpgradeStarNodeItemRedPoint()
end

--@ bid 英雄bid 特殊判断 如果 == nil 说明是随机卡
--@ star 星级
--@ count 数量
--@ camp_type 阵营  如果是随机卡.此一定需要有值
function GW_HeroDetailWindow:getHeroData(bid, star, count, camp_type)
    --模拟 hero_vo 需要的数据
    local data = {}
    data.star = star or 0
    data.count = count or 0
    data.lev = string_format("%s/%s", 0, count)

    if bid == nil then
        data.bid = 0 --表示随机卡
        data.camp_type = camp_type
    else
        local base_config = Config.PartnerData.data_partner_base[bid]
        if base_config then
            data.bid = bid
            data.camp_type = base_config.camp_type
            data.name = base_config.name
        else
            return nil
        end
    end
    --当前选中的英雄列表 [id] == hero_vo 模式
    data.dic_select_list = {}
    return data
end

--刷新皮肤页面
function GW_HeroDetailWindow:updateSkinNode(hero_pokedex_info)
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.Skin then
        return
    end

    local bid_config = Config.PartnerSkinData.data_partner_bid_info[hero_pokedex_info.bid] or {}
    self.skin_data_list = {}
    for skin_id,v in pairs(bid_config) do
        local data = {}
        data.is_skin_data = true -- 表示是皮肤数据
        data.is_lock = false
        if model:isUnlockHeroSkin(v.skin_id) then
            data.is_lock = false
        else
            data.is_lock = true
        end
        data.skin_id = skin_id
        data.config = Config.PartnerSkinData.data_skin_info[v.skin_id]
        table_insert(self.skin_data_list, data)
    end
    table_sort(self.skin_data_list, function(a, b) return a.skin_id <b.skin_id end)
    --第一个肯定是本体
    table_insert(self.skin_data_list, 1, hero_pokedex_info)

    self.skin_node_skin_get_btn:setVisible(false)
    --Debug.log(self.skin_data_list)
    local select_index = 1
    self:updateSkinList(select_index)
end
--刷新传记页面
function GW_HeroDetailWindow:updateLibraryStoryNode(hero_info)
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.LibraryStory then
        return
    end

    self.library_config = Config.PartnerData.data_partner_library(hero_info.bid)
    if self.library_config == nil then
        Debug.error("找不到传记配置！！英雄ID："..hero_info.bid)
        return
    end
    self.library_story_node_des1_value:setString(self.library_config.title)
    self.library_story_node_des2_value:setString(self.library_config.age)
    self.library_story_node_des3_value:setString(self.library_config.size)
    self.library_story_node_des4_value:setString(self.library_config.camp)
    self.library_story_node_chapter_desc:setString(self.library_config.voice_str)

    local desc_bg_height = self.library_story_node_chapter_desc:getContentSize().height + 40
    if desc_bg_height < 100 then
        desc_bg_height = 100
    end
    self.library_story_node_chapter_desc_bg:setContentSize(cc.size(478, desc_bg_height))
    self.library_story_node_chapter_desc:setPositionY(desc_bg_height - 20)

    --self.library_config_story_id = nil
    --self.library_config_id = nil
    --self.library_config_num = nil
    --if self.library_config.story_list ~= nil and next(self.library_config.story_list) ~= nil then
    --    for i,story_id in pairs(self.library_config.story_list) do
    --        local story_config = Config.PartnerData.data_partner_story_fun(story_id)
    --        if story_config ~= nil then
    --
    --        end
    --        break
    --    end
    --end

    local story_len = 0
    --if self.library_config.story_list and next(self.library_config.story_list) then
    --    story_len = #self.library_config.story_list
    --end
    --if story_len > 5 then
    --    story_len = 5
    --end
    for i,item in pairs(self.library_story_node_story_list) do
        if i<= story_len then
            local story_id = self.library_config.story_list[i]
            local story_config = Config.PartnerData.data_partner_story_fun(story_id)
            local is_open = GW_HeroDetailWindow.isStoryOpen(story_id)
            local title = story_config.title
            item.story_id = story_id
            item.label:setString(title)
            if is_open == true then
                item.lock_bg:setVisible(false)
                item.lock_icon:setVisible(false)
            else
                item.lock_bg:setVisible(true)
                item.lock_icon:setVisible(true)
            end
            item.is_open = is_open
            item:setVisible(true)
        else
            item.story_id = nil
            item:setVisible(false)
        end
    end

    local inner_height = desc_bg_height + 25 + story_len * 64 + 10
    if inner_height < 320 then
        inner_height = 320
    end
    self.library_story_node_chapter_desc_bg:setPositionY(inner_height - 16)
    self.library_story_node_story_list_scrollView:setInnerContainerSize(cc.size(500,inner_height))
    self.library_story_node_story_list_scrollView:setScrollBarEnabled(false)
    self.library_story_node_story_list_scrollView:jumpToTop()
    self.library_story_node_chapter_desc_bg:setPositionY(inner_height - 16)
    for i=1,story_len do
        self.library_story_node_story_list[i]:setPositionY(inner_height - 183 - 65*(i-1))
    end

    self:updateLibraryStoryNodeStoryRedpoint()
end
--刷新传记页面-故事红点
function GW_HeroDetailWindow:updateLibraryStoryNodeStoryRedpoint()
    if self.sheet_type ~= GW_HeroBagConst.Hero_Detail_Sheet_Type.LibraryStory then
        return
    end

    if not self.index or not self.show_list then return end
    self.hero_vo = self.show_list[self.index]

    for i,item in pairs(self.library_story_node_story_list) do
        local redpoint = false
        if item.story_id ~= nil and GW_HeroDetailWindow.isStoryHaveReward(item.story_id) ~= nil and GW_HeroDetailWindow.isStoryOpen(item.story_id) == true then
            redpoint = not GW_HeroDetailWindow.isStoryRewardGetted(item.story_id)
        end
        item.redpoint:setVisible(redpoint)
        if redpoint == true then
            if item.redpoint_spine == nil then
                item.redpoint_spine = PathTool.gw_createRedpointSpine()
                item.redpoint:addChild(item.redpoint_spine)
            end
        end
    end
end

function GW_HeroDetailWindow:updateSkinList(select_index)
    if self.skin_scroll_view == nil then
        local scroll_view_size = self.skin_node_lay_scrollview:getContentSize()
        local list_setting = {
            start_x = 10,
            space_x = 5,
            start_y = 0,
            space_y = 0,
            item_width = 168,
            item_height = 274,
            row = 1,
            col = 1,
            need_dynamic = true
        }
        self.skin_scroll_view = CommonScrollViewSingleLayout.new(self.skin_node_lay_scrollview, cc.p(0, 0), ScrollViewDir.horizontal, ScrollViewStartPos.top, scroll_view_size, list_setting, cc.p(0, 0))

        self.skin_scroll_view:registerScriptHandlerSingle(handler(self,self.createNewCell_skin), ScrollViewFuncType.CreateNewCell) --创建cell
        self.skin_scroll_view:registerScriptHandlerSingle(handler(self,self.numberOfCells_skin), ScrollViewFuncType.NumberOfCells) --获取数量
        self.skin_scroll_view:registerScriptHandlerSingle(handler(self,self.updateCellByIndex_skin), ScrollViewFuncType.UpdateCellByIndex) --更新cell
        self.skin_scroll_view:registerScriptHandlerSingle(handler(self,self.onCellTouched_skin), ScrollViewFuncType.OnCellTouched) --更新cell
    end

    self.must_update_skin = true
    local select_index = select_index or 1
    self.skin_scroll_view:reloadData(select_index)
end

--创建cell
--@width 是setting.item_width
--@height 是setting.item_height
function GW_HeroDetailWindow:createNewCell_skin(width, height)
    local cell = ccui.Layout:create()
    cell:setCascadeOpacityEnabled(true)
    cell:setAnchorPoint(0.5,0.5)
    cell:setTouchEnabled(true)
    local size = cc.size(width, height)
    cell:setContentSize(size)

    cell.hero_icon = createSprite(nil, width * 0.5, height * 0.5,cell, cc.p(0.5, 0.5))
    cell.hero_icon:setScaleX(166/320)
    cell.hero_icon:setScaleY(270/521)
    cell.hero_icon:setZOrder(1)
    cell.bg0 = createImage(cell, "resource/gw_hero_bag/gw_hero_handbook_detail_skin_bg1.png", width * 0.5, height * 0.5, cc.p(0.5, 0.5), false, 0 ,false)
    cell.bg1 = createImage(cell, "resource/gw_hero_bag/gw_hero_handbook_detail_skin_bg2.png", width * 0.5, height * 0.5, cc.p(0.5, 0.5), false, 2 ,false)
    cell.name = createLabel(24, cc.c4b(0xff,0xff,0xff,0xff), cc.c4b(0,0,0,0), width * 0.5, 24, TI18N("名字"), cell, 2, cc.p(0.5, 0.5))
    cell.name:setZOrder(3)

    registerButtonEventListener(cell, function() self:onCellTouched_skin(cell)  end ,false, REGISTER_BUTTON_SOUND_BUTTON_TYPY)

    cell.DeleteMe = function()
        if cell.item_load then
            cell.item_load:DeleteMe()
            cell.item_load = nil
        end
    end

    return cell
end
--获取数据数量
function GW_HeroDetailWindow:numberOfCells_skin()
    if not self.skin_data_list then return 0 end
    return #self.skin_data_list
end
--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--index :数据的索引
function GW_HeroDetailWindow:updateCellByIndex_skin(cell, index)
    cell.index = index
    local skin_data = self.skin_data_list[index]
    if not skin_data then return end
    local config = skin_data
    Debug.info(skin_data)

    local res_id
    local name
    if skin_data.is_skin_data then
        res_id = skin_data.config.head_card_id
        name = skin_data.config.skin_name
    else
        res_id = skin_data.bid
        name = skin_data.name
    end
    if cell.record_res_id == nil or cell.record_res_id ~= res_id then
        cell.record_res_id = res_id
        local res = PathTool.getPlistImgForDownLoad("bigbg/partnercard", "partnercard_" ..res_id)
        cell.item_load = loadSpriteTextureFromCDN(cell.hero_icon, res, ResourcesType.single, cell.item_load, 60,function()
            cell.hero_icon:setScaleX(166/320)
            cell.hero_icon:setScaleX(274/521)
            cell.hero_icon:setZOrder(1)
        end)
    end

    cell.name:setString(name or "")
    if self.select_skin_index and self.select_skin_index == index then
        cell.bg1:setVisible(true)
    else
        cell.bg1:setVisible(false)
    end
end

--点击cell .需要在 createNewCell 设置点击事件
function GW_HeroDetailWindow:onCellTouched_skin(cell)
    if not cell.index then return end
    local index = cell.index
    local skin_data = self.skin_data_list[index]
    if not skin_data then return end

    if self.select_cell_skin ~= nil then
        self.select_cell_skin.bg1:setVisible(false)
    end

    self.select_cell_skin = cell
    self.select_cell_skin.bg1:setVisible(true)

    self:updateSelectSkinInfo( index)
end

--更新选中的皮肤信息
function GW_HeroDetailWindow:updateSelectSkinInfo(index)
    if not self.must_update_skin and self.select_skin_index and self.select_skin_index == index then return end
    self.must_update_skin = nil
    self.select_skin_index = index
    local skin_data = self.skin_data_list[self.select_skin_index]

    if skin_data.is_skin_data then
        --皮肤对象
        self.skin_config = skin_data.config
        self:updateSkinAttrInfo()

        if skin_data.is_lock == true then
            self.skin_node_skin_get_btn:setVisible(true)
        else
            self.skin_node_skin_get_btn:setVisible(false)
        end
    else
        --英雄对象
        self.skin_config = Config.PartnerData.data_partner_library(skin_data.bid)
        self:updateSkinAttrInfo()
        self.skin_node_skin_get_btn:setVisible(false)
    end

end

--更新皮肤属性属性
function GW_HeroDetailWindow:updateSkinAttrInfo()
    if not self.skin_config then return end

    for i,v in ipairs(self.skin_node_attr_item_list) do
        v.name:setVisible(false)
    end

    if self.skin_config.skin_attr then
        for i,v in ipairs(self.skin_config.skin_attr) do
            if i>4 then
                break
            end

            self.skin_node_attr_item_list[i].name:setVisible(true)
            local res, attr_name, attr_val = gw_commonGetAttrInfoByKeyValue(v[1], v[2])
            self.skin_node_attr_item_list[i].value:setString(string_format("+%s", attr_val))
            loadSpriteTexture(self.skin_node_attr_item_list[i].icon, res, LOADTEXT_TYPE_PLIST)
        end
    end
end

--刷新页签红点
function GW_HeroDetailWindow:updateSheetRedpoint()
    if not self.index or not self.show_list then return end
    local hero_vo = self.show_list[self.index]
    hero_vo.red_point = {}

    for i,sheet in pairs(self.sheet_btn_list) do
        sheet.red_point:setVisible(false)
    end

    if HeroCalculate.checkSingleHeroLevelUpRedPoint(hero_vo) == true then
        local index = GW_HeroBagConst.Hero_Detail_Sheet_Type.Info+1
        self.sheet_btn_list[index].red_point:setVisible(true)
        if self.sheet_btn_list[index].red_point_spine == nil then
            self.sheet_btn_list[index].red_point_spine = PathTool.gw_createRedpointSpine()
            self.sheet_btn_list[index].red_point:addChild(self.sheet_btn_list[index].red_point_spine)
        end
    end
    if HeroCalculate.checkSingleHeroEquipRedPoint(hero_vo) == true then
        local index = GW_HeroBagConst.Hero_Detail_Sheet_Type.Equip+1
        self.sheet_btn_list[index].red_point:setVisible(true)
        if self.sheet_btn_list[index].red_point_spine == nil then
            self.sheet_btn_list[index].red_point_spine = PathTool.gw_createRedpointSpine()
            self.sheet_btn_list[index].red_point:addChild(self.sheet_btn_list[index].red_point_spine)
        end
    end
    if HeroCalculate.checkSingleHeroUpgradeStarRedPoint(hero_vo) == true then
        local index = GW_HeroBagConst.Hero_Detail_Sheet_Type.UpgradeStar+1
        self.sheet_btn_list[index].red_point:setVisible(true)
        if self.sheet_btn_list[index].red_point_spine == nil then
            self.sheet_btn_list[index].red_point_spine = PathTool.gw_createRedpointSpine()
            self.sheet_btn_list[index].red_point:addChild(self.sheet_btn_list[index].red_point_spine)
        end
    end
    --if GW_HeroDetailWindow.isHeroHaveStoryRewardCanGet(hero_vo.bid) == true then
    --    local index = GW_HeroBagConst.Hero_Detail_Sheet_Type.LibraryStory+1
    --    self.sheet_btn_list[index].red_point:setVisible(true)
    --    if self.sheet_btn_list[index].red_point_spine == nil then
    --        self.sheet_btn_list[index].red_point_spine = PathTool.gw_createRedpointSpine()
    --        self.sheet_btn_list[index].red_point:addChild(self.sheet_btn_list[index].red_point_spine)
    --    end
    --end
    --self.sheet_btn_list[GW_HeroBagConst.Hero_Detail_Sheet_Type.Info+1].red_point:setVisible(HeroCalculate.checkSingleHeroLevelUpRedPoint(hero_vo))
    --self.sheet_btn_list[GW_HeroBagConst.Hero_Detail_Sheet_Type.Equip+1].red_point:setVisible(HeroCalculate.checkSingleHeroEquipRedPoint(hero_vo))
    --self.sheet_btn_list[GW_HeroBagConst.Hero_Detail_Sheet_Type.UpgradeStar+1].red_point:setVisible(HeroCalculate.checkSingleHeroUpgradeStarRedPoint(hero_vo))
    --self.sheet_btn_list[GW_HeroBagConst.Hero_Detail_Sheet_Type.LibraryStory+1].red_point:setVisible(GW_HeroDetailWindow.isHeroHaveStoryRewardCanGet(hero_vo.bid))

    local is_redpoint = HeroCalculate.checkSingleHeroLevelUpRedPoint(hero_vo)
    self.info_node_lv_up_btn_redpoint:setVisible(is_redpoint)
    self.info_node_lev_breach_btn_redpoint:setVisible(is_redpoint)
    if is_redpoint == true then
        if self.info_node_lv_up_btn_redpoint_spine == nil then
            self.info_node_lv_up_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
            self.info_node_lv_up_btn_redpoint:addChild(self.info_node_lv_up_btn_redpoint_spine)
        end
        if self.info_node_lev_breach_btn_redpoint_spine == nil then
            self.info_node_lev_breach_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
            self.info_node_lev_breach_btn_redpoint:addChild(self.info_node_lev_breach_btn_redpoint_spine)
        end
    end
end

--英雄故事是否开启
function GW_HeroDetailWindow.isStoryOpen(story_id)
    if story_id == nil then
        return false
    end
    local story_config = Config.PartnerData.data_partner_story_fun(story_id)
    if story_config == nil then
        return false
    end
    if story_config.dungeon_type <= 0 or story_config.dungeon_id <= 0 then
        return true
    end

    if story_config.dungeon_type == 1 then--主线副本
        return GW_DramaMainlandWindow.isDramaDunOpened(story_config.dungeon_id)
    elseif story_config.dungeon_type == 2 then--支线副本
        return GW_DramaMainlandWindow.isBranchDunOpened(story_config.dungeon_id)
    elseif story_config.dungeon_type == 3 then--自由
        return GW_DramaMainlandWindow.isFreeDunOpened(story_config.dungeon_id)
    else
        return true
    end
end
--获取英雄故事奖励配置（道具ID，道具数量） 若返回nil代表没有奖励
function GW_HeroDetailWindow.isStoryHaveReward(story_id)
    if story_id == nil then
        return nil
    end
    local story_config = Config.PartnerData.data_partner_story_fun(story_id)
    if story_config == nil then
        return nil
    end

    if story_config.reward == nil or #story_config.reward < 1 or story_config.reward[1] == nil or #story_config.reward[1] < 2 then
        return nil
    end

    return story_config.reward
end
--英雄故事奖励是否已领取
function GW_HeroDetailWindow.isStoryRewardGetted(story_id)
    if story_id == nil then
        return false
    end

    local getted_story_ids = HeroController:getInstance():getModel().gw_hero_story_data
    if getted_story_ids == nil or getted_story_ids.story_ids == nil or #getted_story_ids.story_ids <= 0 then
        return false
    end

    for i,id in pairs(getted_story_ids.story_ids) do
        if id.story_id == story_id then
            return true
        end
    end

    return false
end
--英雄是否有故事奖励可领取
function GW_HeroDetailWindow.isHeroHaveStoryRewardCanGet(bid)
    local library_config = Config.PartnerData.data_partner_library(bid)
    if library_config == nil or library_config.story_list == nil or next(library_config.story_list) == nil then
        return false
    end

    for i,story_id in pairs(library_config.story_list) do
        local redpoint = false
        if story_id ~= nil and GW_HeroDetailWindow.isStoryHaveReward(story_id) ~= nil and GW_HeroDetailWindow.isStoryOpen(story_id) == true then
            redpoint = not GW_HeroDetailWindow.isStoryRewardGetted(story_id)
        end
        if redpoint == true then
            return true
        end
    end

    return false
end
