---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/21 8:20
---
GW_StoryController = GW_StoryController or BaseClass(BaseController)

function GW_StoryController:config()
    self.model = GW_StoryModel.New(self)
    self.dispather = GlobalEvent:getInstance()
end

function GW_StoryController:getModel()
    return self.model
end


function GW_StoryController:registerEvents()
end

function GW_StoryController:registerProtocals()
    self:RegisterProtocal(11130, "handle_11130")    -- 推送要播放的剧情ID
    self:RegisterProtocal(11131, "handle_11131")    -- 剧情播放完毕
    self:RegisterProtocal(11132, "handle_11132")    -- 跳过剧情
    self:RegisterProtocal(11133, "handle_11133")    -- 获取已播放剧情
end

--打开故事界面
function GW_StoryController:openView(story_id, is_reback, call_back_func)
    self.call_back_func = call_back_func
    if not Config.ScriptsData.data_drama or not Config.ScriptsData.data_drama[story_id] then
        story_id = 101
        --message("剧情表找不到剧情配置！！剧情ID:"..story_id)
        --self:send_11131(story_id)
        --return
    end

    if not Config.ScriptsData.data_drama[story_id].step or #Config.ScriptsData.data_drama[story_id].step <= 0 then
        message("该剧情没有任何剧情步骤！！剧情ID:"..story_id)
        self:send_11131(story_id)
        return
    end


    if not self.gw_story_view then
        self.gw_story_view = GW_StoryWindow.New()
    end
    if not self.gw_story_view:isOpen() then
        self.gw_story_view:open(story_id, is_reback)
    end
end

--关闭故事界面
function GW_StoryController:closeView()
    if self.call_back_func and "function" == type(self.call_back_func) then
        local drama_data = {}
        drama_data.drama_bid = self.gw_story_view.story_id
        local step = self.gw_story_view.step_list[self.gw_story_view.step_index]
        step = step or 0
        drama_data.step = step
        drama_data.type = 0
        drama_data.args1 = 0
        drama_data.args2 = 0
        drama_data.args3 = 0
        self:call_back_func(drama_data)
    end
    if self.gw_story_view then
        self.gw_story_view:close()
        self.gw_story_view = nil
    end
end

function GW_StoryController:__delete()
end
function GW_StoryController:DeleteMe()
    if self.model ~= nil then
        self.model:DeleteMe()
        self.model = nil
    end
end

--推送要播放的剧情ID
function GW_StoryController:handle_11130(data)
    HeroController:getInstance():openFormGoFightPanel(false)
    self:openView(data.drama_bid, false)
end
--剧情播放完毕
function GW_StoryController:handle_11131(data)
    self:closeView()
    self:send_11133()--剧情播放完毕意味着已有剧情列表有变化，所以这里同步一下已有剧情列表
end
function GW_StoryController:send_11131(drama_bid)
    local protocal = {}
    protocal.drama_bid = drama_bid
    self:SendProtocal(11131, protocal)
end
--跳过剧情
function GW_StoryController:handle_11132(data)
    self:closeView()
    self:send_11133()--跳过剧情意味着已有剧情列表有变化，所以这里同步一下已有剧情列表
end
function GW_StoryController:send_11132(drama_bid, step, drama_data)
    local protocal = {}
    protocal.drama_bid = drama_bid
    step = step or 0
    protocal.step = step
    protocal.type = drama_data.type or 0
    protocal.args1 = drama_data.args1 or 0
    protocal.args2 = drama_data.args2 or 0
    protocal.args3 = drama_data.args3 or 0
    local story_config = Config.ScriptsData.data_drama[drama_bid]
    if story_config ~= nil then
        protocal.type = story_config.type or 0
        protocal.args1 = story_config.land_id or 0
        protocal.args2 = story_config.building_id or 0
        protocal.args3 = story_config.dungeon_id or 0
    end
    dump(protocal, "protocal = ", 8)
    self:SendProtocal(11132, protocal)
end
--获取已播放剧情
function GW_StoryController:handle_11133(data)
    --Debug.log("获取已播放剧情")
    --Debug.info(data)
    self.model:updateHadStoryList(data.drama_list)
    ActionController:getInstance():gw_openFirstChargeViewForEveryDay(data.drama_list)
end
function GW_StoryController:send_11133()
    local protocal = {}
    self:SendProtocal(11133, protocal)
end